{
TGMPolyline demo program

  ES: programa de demostracin de uso del componente TGMPolyline
  EN: demo program use of component TGMPolyline

=========================================================================
History:

ver 0.1:
  ES- primera versin
  EN- first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit UPolygonFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls,
  GMPolygon;

type
  TPolygonFrm = class(TForm)
    cbClickable: TCheckBox;
    cbGeodesic: TCheckBox;
    cbVisible: TCheckBox;
    cbEditable: TCheckBox;
    Label36: TLabel;
    cbStrokeColor: TColorBox;
    eStrokeOpacity: TEdit;
    Label37: TLabel;
    Label38: TLabel;
    eStrokeWeight: TSpinEdit;
    Label39: TLabel;
    lbLinePoints: TListBox;
    bDelLP: TButton;
    bUpLP: TButton;
    bDownLP: TButton;
    Shape1: TShape;
    mHTMLContent: TMemo;
    Label1: TLabel;
    cbCloseOtherBeforeOpen: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    cbFillColor: TColorBox;
    eFillOpacity: TEdit;
    procedure bDelLPClick(Sender: TObject);
    procedure cbClickableClick(Sender: TObject);
    procedure cbEditableClick(Sender: TObject);
    procedure cbGeodesicClick(Sender: TObject);
    procedure cbVisibleClick(Sender: TObject);
    procedure cbStrokeColorChange(Sender: TObject);
    procedure eStrokeOpacityChange(Sender: TObject);
    procedure eStrokeWeightChange(Sender: TObject);
    procedure cbCloseOtherBeforeOpenClick(Sender: TObject);
    procedure mHTMLContentChange(Sender: TObject);
    procedure bUpLPClick(Sender: TObject);
    procedure cbFillColorChange(Sender: TObject);
    procedure eFillOpacityChange(Sender: TObject);
  private
    FGMPoly: TGMPolygon;
    FIndex: Integer;
  public
    constructor Create(aOwner: TComponent; GMPoly: TGMPolygon; Index: Integer); reintroduce; virtual;
  end;

var
  PolygonFrm: TPolygonFrm;

implementation

{$R *.dfm}

{ TPolylineFrm }

procedure TPolygonFrm.bDelLPClick(Sender: TObject);
begin
  if lbLinePoints.ItemIndex = -1 then Exit;

  FGMPoly[FIndex].DeleteLinePoint(lbLinePoints.ItemIndex);
  lbLinePoints.DeleteSelected;
end;

procedure TPolygonFrm.bUpLPClick(Sender: TObject);
begin
  if lbLinePoints.ItemIndex = -1 then Exit;
  if lbLinePoints.ItemIndex = 0 then Exit;

  FGMPoly[FIndex].MoveLinePoint(lbLinePoints.ItemIndex, lbLinePoints.ItemIndex-1);
  lbLinePoints.Items.Move(lbLinePoints.ItemIndex, lbLinePoints.ItemIndex-1);
end;

procedure TPolygonFrm.cbClickableClick(Sender: TObject);
begin
  FGMPoly[FIndex].Clickable := cbClickable.Checked;
end;

procedure TPolygonFrm.cbCloseOtherBeforeOpenClick(Sender: TObject);
begin
  FGMPoly[FIndex].InfoWindow.CloseOtherBeforeOpen := cbCloseOtherBeforeOpen.Checked;
end;

procedure TPolygonFrm.cbEditableClick(Sender: TObject);
begin
  FGMPoly[FIndex].Editable := cbEditable.Checked;
end;

procedure TPolygonFrm.cbFillColorChange(Sender: TObject);
begin
  FGMPoly[FIndex].FillColor := cbFillColor.Selected;
end;

procedure TPolygonFrm.cbGeodesicClick(Sender: TObject);
begin
  FGMPoly[FIndex].Geodesic := cbGeodesic.Checked;
end;

procedure TPolygonFrm.cbStrokeColorChange(Sender: TObject);
begin
  FGMPoly[FIndex].StrokeColor := cbStrokeColor.Selected;
end;

procedure TPolygonFrm.cbVisibleClick(Sender: TObject);
begin
  FGMPoly[FIndex].Visible := cbVisible.Checked;
end;

constructor TPolygonFrm.Create(aOwner: TComponent; GMPoly: TGMPolygon; Index: Integer);
var
  i: Integer;
begin
  inherited Create(aOwner);

  FGMPoly := GMPoly;
  FIndex := Index;

  cbClickable.Checked := FGMPoly[FIndex].Clickable;
  cbGeodesic.Checked := FGMPoly[FIndex].Geodesic;
  cbEditable.Checked := FGMPoly[FIndex].Editable;
  cbVisible.Checked := FGMPoly[FIndex].Visible;
  cbStrokeColor.Selected := FGMPoly[FIndex].StrokeColor;
  eStrokeOpacity.Text := FloatToStr(FGMPoly[FIndex].StrokeOpacity);
  eStrokeWeight.Value := FGMPoly[FIndex].StrokeWeight;
  mHTMLContent.Lines.Text := FGMPoly[FIndex].InfoWindow.HTMLContent;
  cbCloseOtherBeforeOpen.Checked := FGMPoly[FIndex].InfoWindow.CloseOtherBeforeOpen;
  cbFillColor.Selected := FGMPoly[FIndex].FillColor;
  eFillOpacity.Text := FloatToStr(FGMPoly[FIndex].FillOpacity);

  lbLinePoints.Clear;
  for i := 0 to FGMPoly[FIndex].LinePoints.Count - 1 do
  begin

    lbLinePoints.Items.Add(FGMPoly[FIndex][i].LatToStr(FGMPoly.Map.Precision) + ' - ' +
                           FGMPoly[FIndex][i].LngToStr(FGMPoly.Map.Precision));
  end;
end;

procedure TPolygonFrm.eFillOpacityChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eFillOpacity.Text, F) then
    FGMPoly[FIndex].FillOpacity := F;
end;

procedure TPolygonFrm.eStrokeOpacityChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eStrokeOpacity.Text, F) then
    FGMPoly[FIndex].StrokeOpacity := F;
end;

procedure TPolygonFrm.eStrokeWeightChange(Sender: TObject);
var
  F: Integer;
begin
  if TryStrToInt(eStrokeWeight.Text, F) then
    FGMPoly[FIndex].StrokeWeight := F;
end;

procedure TPolygonFrm.mHTMLContentChange(Sender: TObject);
begin
  FGMPoly[FIndex].InfoWindow.HTMLContent := mHTMLContent.Lines.Text;
end;

end.
