{
TGMMap component

  ES: componente para usar el mapa de Google Maps
  EN: component to use the Google Maps map

=========================================================================
MODO DE USO/HOW TO USE

  ES: poner el componente en el formulario, linkarlo a un TWebBrowser,
      Activarlo y ejecutar el mtodo DoMap
  EN: put the component into a form, link to a TWebBrowser, put Active and
      call DoMap method
=========================================================================
History:

ver 0.1.7
  ES:
    cambio: TGMMap.TNonVisualProp -> aadida propiedad MapMaker. A true si queremos
      que los mosaicos de Map Marker se muestren en lugar de los normales
    cambio: TLatLngEvent -> los eventos de este tipo ahora reciben dos nuevos
      parmetros, X y Y, de tipo Real, con la informacin del punto (X,Y)
    cambio: TLinkedComponent -> aadida propiedad booleana ShowInfoWinMouseOver. A
      true, se mostrar el InfoWindows mientras el ratn est encima del objeto.
      Actualmente vlido slo para TMarker (por Luis Joaquin Sencion).
    cambio: TLinkedComponent -> aadido mtodo protegido ChangeProperties para
      centralizar en un slo sitio el cambio de las propiedades de los objectos.
  EN:
    change: TGMMap.TNonVisualProp -> added MapMarker property. True if Map Maker tiles
      should be used instead of regular tiles.
    change: TLatLngEvent -> the events of this type now have two new parametres,
      X and Y, of Real type, with information of point (X,Y)
    change: TLinkedComponent -> added ShowInfoWinMouseOver boolean property. If true,
      show the InfoWindows when mouse is over the object. Now only valid for TMarker
      (by Luis Joaquin Sencion).
    change: TLinkedComponent -> added ChangeProperties protected method to centralize
      in one place the changes of properties of the objects

ver 0.1.6
  ES:
    nuevo: TGMObjects -> nueva clase que hereda de TGMBase y de la que heredarn
      clases como TGMLinkedComponent o TGMDirection
    nuevo: TGMMaps -> aadida propiedad Layers para el acceso a las capas de
      Google Maps como:
        a) Panoramio (clase TPanoramio)
        b) Traffic (clase TTraffic)
        c) Transit (clase TTransit)
        d) Bicyclig (clase TBicycling)
        e) Weather (clase TWeather)
    nuevo: TGMMaps -> aadidos eventos OnWeatherClick y FOnPanoramioClick
    cambio: TGMMaps -> se cambian los mtodos xxToStr y StrToxxx para reducir cdigo
    cambio: TGMMaps -> los mtodos Printxxxx y SaveToJPGFile usan los mtodos de la
      unidad WebControls
  EN:
    new: TGMObjects -> new class that inherits from TGMBase and the classes that
      inherit as TGMLinkedComponent or TGMDrection
    new: TGMMaps -> added Layers property to access Google Maps layers like:
        a) Panoramio (TPanoramio class)
        b) Traffic (TTraffic class)
        c) Transit (TTransit class)
        d) Bicyclig (TBicycling class)
        e) Weather (TWeather class)
    new: TGMMaps -> added OnWeatherClick and FOnPanoramioClick events
    change: TGMMaps -> changed xxToStr and StrToxxx methods to reduce code
    change: TGMMaps -> the Printxxxx and SaveToJPGFile methods now uses methods
      of WebControls unit

ver 0.1.5
  ES:
    nuevo: TGMMap -> aadidos eventos OnActiveChange, OnIntervalEventsChange y
      OnPrecisionChange
    error: TGMMap -> corregido error en RemoveLinkedComponent cuando se intentaba
      suprimir un objeto sin estar la lista creada
    error: cuando haba figuras de diferentes tipos juntas, daba un error de JS
      al pasar el ratn sobre ellas (gracias Erasmo)
    cambio: TGMMap -> se controlan los mtodos Set de las propiedades Zoom y MapType
      para actualizar el mapa automticamente
    nuevo: TLinkedComponent -> se aade la propiedad Text (visible a todos sus
      descendientes menos a TMarker porque ya tiene la propiedad Title)
    nuevo: TGMLinkedComponent -> aadida propiedad Count
    cambio: Zoom, MaxZoom y MinZoom se limitan al rango de 0 a 15
  EN:
    new: TGMMap -> added events OnActiveChange, OnIntervalEventsChange and
      OnPrecisionChange
    bug: TGMMap -> bug fixed on RemoveLinkedComponent when trying delete an
      object without being the list created
    bug: when it had figures of different types together, there was a JS error
      when you move the mouse over them (thanks Erasmo)
    change: TGMMap -> control Set methods of Zoom and MapType properties to update
      map automatically
    new: TLinkedComponent -> Text property added (visible to all his descendants
      except TMarker because it has the Title property)
    new: TGMLinkedComponent -> Count property added
    change: Zoom, MaxZoom and MinZoom are limited at range 0 to 15

ver 0.1.4
  ES:
    nuevo: TGMMap -> aadidos mtodos PrintNoDialog, PrintWithDialog,
      PrintPreview, PrintPageSetup y SaveToJPGFile para imprimir y guardar el mapa
  EN:
    new: TGMMap -> added methods PrintNoDialog, PrintWithDialog, PrintPreview,
      PrintPageSetup and SaveToJPGFile to print and save map

ver 0.1.3
  ES:
    nuevo: TLinkedComponent -> aadida propiedad Tag: Integer (published)
    nuevo: TLinkedComponent -> aadida propiedad FObject: TObject (public)
  EN:
    new: TLinkedComponent -> property Tag: Integer added (published)
    new: TLinkedComponent -> property FObject: TObject added (public)

ver 0.1.1:
  ES:
    nuevo: Se ha aadido el mtodo Clear a la clase base TGMLinkedComponent.
    nuevo: Se ha aadido el mtodo Assign a la clase base TGMLinkedComponent.
    nuevo: Se ha aadido el mtodo Clear en la clase base TLinkedComponents.
    bug: Correccin de algn bug
  EN:
    new: Added Clear method to the TGMLinkedComponent base class.
    new: Added Assign method to the TGMLinkedComponent base class.
    new: Added Clear method to the TLinkedComponents base class.
    bug: Some bugs fixed

ver 0.1:
  ES: primera versin
  EN: first version
=========================================================================
ES: IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

EN: IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit GMMap;

interface

uses
  Classes, ExtCtrls, SHDocVw, Graphics, SysUtils, Contnrs,
  GMBase, GMConstants, GMLatLng, GMLatLngBounds, GMBaseInfoWindow;

type
  TEventsFired = record
    Map: Boolean;
    InfoWin: Boolean;
    Marker: Boolean;
    Polyline: Boolean;
    Rectangle: Boolean;
    Circle: Boolean;
    Direction: Boolean;
  end;

  TEventsMapForm = record
      // map
    BoundsChanged: Boolean;
    CenterChanged: Boolean;
    Click: Boolean;
    DblClick: Boolean;
    Drag: Boolean;
    DragEnd: Boolean;
    DragStart: Boolean;
    MapTypeIdChanged: Boolean;
    MouseMove: Boolean;
    MouseOut: Boolean;
    MouseOver: Boolean;
    RightClick: Boolean;
    TilesLoaded: Boolean;
    ZoomChanged: Boolean;
    SWLat: Real;
    SWLng: Real;
    NELat: Real;
    NELng: Real;
    Lat: Real;
    Lng: Real;
    X: Real;
    Y: Real;
    MapTypeId: string;
    Zoom: Integer;
    WeatherClick: Boolean;
    WeatherLat: Real;
    WeatherLng: Real;
    WeatherFeature: string;
    PanoClick: Boolean;
    PanoLat: Real;
    PanoLng: Real;
    PanoAuthor: string;
    PanoPhotoId: string;
    PanoTitle: string;
    PanoUrl: string;
    PanoUserId: string;
  end;

  TEventsMarkerForm = record
    // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
    Lat: Real;
    Lng: Real;
    // events
    Click: Boolean;
    DblClick: Boolean;
    Drag: Boolean;
    DragEnd: Boolean;
    DragStart: Boolean;
    MouseDown: Boolean;
    MouseOut: Boolean;
    MouseOver: Boolean;
    MouseUp: Boolean;
    RightClick: Boolean;
  end;

  TEventsInfoWindowForm = record
    // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
    // InfoWindow
    InfoWinCloseClick: Boolean;
  end;

  TEventsPolylineForm = record
    // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
    Lat: Real;
    Lng: Real;
    // events
    Click: Boolean;
    DblClick: Boolean;
    MouseDown: Boolean;
    MouseMove: Boolean;
    MouseOut: Boolean;
    MouseOver: Boolean;
    MouseUp: Boolean;
    RightClick: Boolean;
  end;

  TEventsRectangleForm = record
    // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
    Lat: Real;
    Lng: Real;
    NELat: Real;
    NELng: Real;
    SWLat: Real;
    SWLng: Real;
    // events
    BoundsChange: Boolean;
    Click: Boolean;
    DblClick: Boolean;
    MouseDown: Boolean;
    MouseMove: Boolean;
    MouseOut: Boolean;
    MouseOver: Boolean;
    MouseUp: Boolean;
    RightClick: Boolean;
  end;

  TEventsCircleForm = record
    // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
    Lat: Real;
    Lng: Real;
    Radius: Real;
    // events
    CenterChange: Boolean;
    RadiusChange: Boolean;
    Click: Boolean;
    DblClick: Boolean;
    MouseDown: Boolean;
    MouseMove: Boolean;
    MouseOut: Boolean;
    MouseOver: Boolean;
    MouseUp: Boolean;
    RightClick: Boolean;
  end;

  TEventsDirectionForm = record
    // general
    LinkCompId: Integer;
    LinkCompZIndex: Integer;
    XML: string;
    // events
    DirectionsChanged: Boolean;
  end;

  TGMObjects = class;
  TGMLinkedComponent = class;
  TGMMap = class;

  TMapTypeIds = set of TMapTypeId;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#MapTypeControlOptions
  **************************************************************************** }
  TMapTypeControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FStyle: TMapTypeControlStyle;
    FMapTypeIds: TMapTypeIds;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property MapTypeIds: TMapTypeIds read FMapTypeIds write FMapTypeIds default [mtHYBRID, mtROADMAP, mtSATELLITE, mtTERRAIN]; // mapTypeIds
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Style: TMapTypeControlStyle read FStyle write FStyle; // style
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#OverviewMapControlOptions
  **************************************************************************** }
  TOverviewMapControlOptions = class(TPersistent)
  private
    FOpened: Boolean;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Opened: Boolean read FOpened write FOpened;  // opened
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#PanControlOptions
  **************************************************************************** }
  TPanControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#RotateControlOptions
  **************************************************************************** }
  TRotateControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#ScaleControlOptions
  **************************************************************************** }
  TScaleControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FStyle: TScaleControlStyle;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Style: TScaleControlStyle read FStyle write FStyle;  // style
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#StreetViewControlOptions
  **************************************************************************** }
  TStreetViewControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#ZoomControlOptions
  **************************************************************************** }
  TZoomControlOptions = class(TPersistent)
  private
    FPosition: TControlPosition;
    FStyle: TZoomControlStyle;
    FShow: Boolean;
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Position: TControlPosition read FPosition write FPosition;   // position
    property Style: TZoomControlStyle read FStyle write FStyle;  // style
    property Show: Boolean read FShow write FShow;
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TVisualProp = class(TPersistent)
  private
    FMapTypeCtrl: TMapTypeControlOptions;
    FOverviewMapCtrl: TOverviewMapControlOptions;
    FPanCtrl: TPanControlOptions;
    FRotateCtrl: TRotateControlOptions;
    FScaleCtrl: TScaleControlOptions;
    FStreetViewCtrl: TStreetViewControlOptions;
    FZoomCtrl: TZoomControlOptions;
    FBGColor: TColor;
  public
    constructor Create; virtual;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;
  published
    property BGColor: TColor read FBGColor write FBGColor;    // backgroundColor
    property MapTypeCtrl: TMapTypeControlOptions read FMapTypeCtrl write FMapTypeCtrl;
    property OverviewMapCtrl: TOverviewMapControlOptions read FOverviewMapCtrl write FOverviewMapCtrl;
    property PanCtrl: TPanControlOptions read FPanCtrl write FPanCtrl;
    property RotateCtrl: TRotateControlOptions read FRotateCtrl write FRotateCtrl;
    property ScaleCtrl: TScaleControlOptions read FScaleCtrl write FScaleCtrl;
    property StreetViewCtrl: TStreetViewControlOptions read FStreetViewCtrl write FStreetViewCtrl;
    property ZoomCtrl: TZoomControlOptions read FZoomCtrl write FZoomCtrl;
  end;

  TBoolOption = (DisableDoubleClickZoom, Draggable, KeyboardShortcuts, NoClear, ScrollWheel);
  TBoolOptions = set of TBoolOption;
  { ****************************************************************************
    internal class
  **************************************************************************** }
  TNonVisualProp = class(TPersistent)
  private
    FOptions: TBoolOptions;
    FMinZoom: Integer;
    FMaxZoom: Integer;
    FMapMaker: Boolean;
    procedure SetMaxZoom(const Value: Integer);
    procedure SetMinZoom(const Value: Integer);
  public
    constructor Create; virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Options: TBoolOptions read FOptions write FOptions default [Draggable, KeyboardShortcuts, ScrollWheel];
    property MaxZoom: Integer read FMaxZoom write SetMaxZoom;   // maxZoom, 0 = null
    property MinZoom: Integer read FMinZoom write SetMinZoom;   // minZoom, 0 = null
    property MapMaker: Boolean read FMapMaker write FMapMaker;
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TRequiredProp = class(TPersistent)
  private
    FCenter: TLatLng;
    FZoom: Integer;
    FMapType: TMapTypeId;
    FGMMap: TGMMap;
    procedure SetZoom(const Value: Integer);
    procedure SetMapType(const Value: TMapTypeId);
  public
    constructor Create(GMMap: TGMMap); virtual;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;
  published
    property Center: TLatLng read FCenter write FCenter;         // center
    property MapType: TMapTypeId read FMapType write SetMapType; // mapTypeId
    property Zoom: Integer read FZoom write SetZoom;             // zoom
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/layers?hl=en#PanoramioLibrary
  **************************************************************************** }
  TPanoramio = class(TPersistent)
  private
    FGMMap: TGMMap;
    FShow: Boolean;
    FFiltered: Boolean;
    FFilterTag: string;
    FClickable: Boolean;
    FFilterUserId: string;
    procedure SetShow(const Value: Boolean);
    procedure SetFilterTag(const Value: string);
    procedure SetFiltered(const Value: Boolean);
    procedure SetClickable(const Value: Boolean);
    procedure SetFilterUserId(const Value: string);

    procedure SetOptions;
  public
    constructor Create(GMMap: TGMMap); virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Show: Boolean read FShow write SetShow;
    property FilterTag: string read FFilterTag write SetFilterTag;
    property FilterUserId: string read FFilterUserId write SetFilterUserId;
    property Filtered: Boolean read FFiltered write SetFiltered;
    property Clickable: Boolean read FClickable write SetClickable;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#PanoramioFeature
  **************************************************************************** }
  TPanoramioFeature = class
  private
    FAuthor: string;
    FUserId: string;
    FPhotoId: string;
    FTitle: string;
    FUrl: string;
  public
    property Author: string read FAuthor;
    property PhotoId: string read FPhotoId;
    property Title: string read FTitle;
    property Url: string read FUrl;
    property UserId: string read FUserId;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/layers?hl=en#TrafficLayer
  **************************************************************************** }
  TTraffic = class(TPersistent)
  private
    FGMMap: TGMMap;
    FShow: Boolean;
    procedure SetShow(const Value: Boolean);
  public
    constructor Create(GMMap: TGMMap); virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Show: Boolean read FShow write SetShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/layers?hl=en#TransitLayer
  **************************************************************************** }
  TTransit = class(TPersistent)
  private
    FGMMap: TGMMap;
    FShow: Boolean;
    procedure SetShow(const Value: Boolean);
  public
    constructor Create(GMMap: TGMMap); virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Show: Boolean read FShow write SetShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/layers?hl=en#BicyclingLayer
  **************************************************************************** }
  TBicycling = class(TPersistent)
  private
    FGMMap: TGMMap;
    FShow: Boolean;
    procedure SetShow(const Value: Boolean);
  public
    constructor Create(GMMap: TGMMap); virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Show: Boolean read FShow write SetShow;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/layers?hl=en#WeatherLayer
  **************************************************************************** }
  TWeather = class(TPersistent)
  private
    FGMMap: TGMMap;
    FShow: Boolean;
    FWindSpeedUnit: TWindSpeedUnit;
    FTemperatureUnit: TTemperatureUnit;
    FLabelColor: TLabelColor;
    FSuppressInfoWindows: Boolean;
    FClickable: Boolean;
    procedure SetShow(const Value: Boolean);
    procedure SetClickable(const Value: Boolean);
    procedure SetLabelColor(const Value: TLabelColor);
    procedure SetSuppressInfoWindows(const Value: Boolean);
    procedure SetTemperatureUnit(const Value: TTemperatureUnit);
    procedure SetWindSpeedUnit(const Value: TWindSpeedUnit);

    procedure SetOptions;
  public
    constructor Create(GMMap: TGMMap); virtual;

    procedure Assign(Source: TPersistent); override;
  published
    property Show: Boolean read FShow write SetShow;
    property Clickable: Boolean read FClickable write SetClickable;
    property LabelColor: TLabelColor read FLabelColor write SetLabelColor;
    property SuppressInfoWindows: Boolean read FSuppressInfoWindows write SetSuppressInfoWindows;
    property TemperatureUnit: TTemperatureUnit read FTemperatureUnit write SetTemperatureUnit;
    property WindSpeedUnit: TWindSpeedUnit read FWindSpeedUnit write SetWindSpeedUnit;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#WeatherConditions
  **************************************************************************** }
  TWeatherConditions = class
  private
    FLow: Integer;
    FHumidity: Integer;
    FWindSpeed: Integer;
    FDay: string;
    FWindDirection: string;
    FHigh: Integer;
    FDescription: string;
    FTemperature: Integer;
    FShortDay: string;
  public
    property Day: string read FDay;
    property Description: string read FDescription;
    property High: Integer read FHigh;
    property Humidity: Integer read FHumidity;
    property Low: Integer read FLow;
    property ShortDay: string read FShortDay;
    property Temperature: Integer read FTemperature;
    property WindDirection: string read FWindDirection;
    property WindSpeed: Integer read FWindSpeed;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#WeatherForecast
  **************************************************************************** }
  TWeatherForecast = class
  private
    FLow: Integer;
    FDay: string;
    FHigh: Integer;
    FDescription: string;
    FShortDay: string;
  public
    property Day: string read FDay;
    property Description: string read FDescription;
    property High: Integer read FHigh;
    property Low: Integer read FLow;
    property ShortDay: string read FShortDay;
  end;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference#WeatherFeature
  **************************************************************************** }
  TWeatherFeature = class
  private
    FLocation: string;
    FCurrent: TWeatherConditions;
    FTemperatureUnit: TTemperatureUnit;
    FWindSpeedUnit: TWindSpeedUnit;
    FForecast: TObjectList;
    function GetCount: Integer;
    function GetForecast(Index: Integer): TWeatherForecast;
  protected
    procedure ProcessXMLData(Data: string);
  public
    constructor Create; virtual;
    destructor Destroy; override;

    property Current: TWeatherConditions read FCurrent;
    property Location: string read FLocation;
    property TemperatureUnit: TTemperatureUnit read FTemperatureUnit;
    property WindSpeedUnit: TWindSpeedUnit read FWindSpeedUnit;
    property Forecast[Index: Integer]: TWeatherForecast read GetForecast;
    property Count: Integer read GetCount;
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TLayers = class(TPersistent)
  private
    FGMMap: TGMMap;
    FPanoramio: TPanoramio;
    FTraffic: TTraffic;
    FTransit: TTransit;
    FBicycling: TBicycling;
    FWeather: TWeather;
  public
    constructor Create(GMMap: TGMMap); virtual;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;
  published
    property Panoramio: TPanoramio read FPanoramio write FPanoramio;
    property Traffic: TTraffic read FTraffic write FTraffic;
    property Transit: TTransit read FTransit write FTransit;
    property Bicycling: TBicycling read FBicycling write FBicycling;
    property Weather: TWeather read FWeather write FWeather;
  end;

  TAfterPageLoaded = procedure(Sender: TObject; First: Boolean) of object;
  TBoundsChanged = procedure(Sender: TObject; NewBounds: TLatLngBounds) of object;
  TLatLngEvent = procedure(Sender: TObject; LatLng: TLatLng; X, Y: Real) of object;
  TMapTypeIdChanged = procedure(Sender: TObject; NewMapTypeId: TMapTypeId) of object;
  TZoomChanged = procedure(Sender: TObject; NewZoom: Integer) of object;
  TWeatherClick = procedure(Sender: TObject; LatLng: TLatLng; FeatureDetails: TWeatherFeature) of object;
  TPanoramioClick = procedure(Sender: TObject; LatLng: TLatLng; PanoramioFeature: TPanoramioFeature) of object;

  { ****************************************************************************
    https://developers.google.com/maps/documentation/javascript/reference?hl=en#Map
  **************************************************************************** }
  TGMMap = class(TGMBase)
  private
    // internal variables
    FTimer: TTimer;          // ES: TTimer para el control de eventos - EN: TTimer for events control
    CurDispatch: IDispatch;  // ES: variable para el control de la carga de la pgina web - EN: variable for control of load web page
    FDocLoaded: Boolean;     // ES: indica si la pgina web se ha cargado completamente - EN: indicates if the Web page is fully loaded
    OldBeforeNavigate2: TWebBrowserBeforeNavigate2;     // ES: evento de TWebBrowser - EN: event of TWebBrowser
    OldDocumentComplete: TWebBrowserDocumentComplete;   // ES: evento de TWebBrowser - EN: event of TWebBrowser
    OldNavigateComplete2: TWebBrowserNavigateComplete2; // ES: evento de TWebBrowser - EN: event of TWebBrowser
    FLinkedComponents: TList;   // ES: lista de componentes unidos al mapa - EN: list of components linked to map
    FCountLinkedCom: Cardinal;  // ES: contador de componentes que estn unidos (o se unieron) al mapa
                                // EN: count components are linked (or have linked) to map
    FIsUpdating: Boolean;
    FIsDoMap: Boolean;

    // from propertis
    FIntervalEvents: Integer;
    FWebBrowser: TWebBrowser;
    FActive: Boolean;
    FAfterPageLoaded: TAfterPageLoaded;
    FRequiredProp: TRequiredProp;
    FVisualProp: TVisualProp;
    FNonVisualProp: TNonVisualProp;
    FOnBoundsChanged: TBoundsChanged;
    FPrecision: Integer;
    FOnCenterChanged: TLatLngEvent;
    FOnClick: TLatLngEvent;
    FOnDblClick: TLatLngEvent;
    FOnDrag: TNotifyEvent;
    FOnDragStart: TNotifyEvent;
    FOnDragEnd: TNotifyEvent;
    FOnMapTypeIdChanged: TMapTypeIdChanged;
    FOnMouseMove: TLatLngEvent;
    FOnMouseOut: TLatLngEvent;
    FOnMouseOver: TLatLngEvent;
    FOnRightClick: TLatLngEvent;
    FOnZoomChanged: TZoomChanged;
    FOnActiveChange: TNotifyEvent;
    FOnIntervalEventsChange: TNotifyEvent;
    FOnPrecisionChange: TNotifyEvent;
    FLayers: TLayers;
    FOnWeatherClick: TWeatherClick;
    FOnPanoramioClick: TPanoramioClick;

    // ES: eventos del TWebBrowser para el control de la carga de la pgina
    // EN: events of TWebBrowser to control the load page
    {$IF CompilerVersion < 22}  // ES: si la versin es inferior a la XE - EN: if lower than XE version
    procedure BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
      var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
    procedure DocumentComplete(ASender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    procedure NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    {$ELSE}                     // ES: si la verisn es la XE o superior - EN: if version is XE or higher
    procedure BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
      const URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
    procedure DocumentComplete(ASender: TObject; const pDisp: IDispatch;
      const URL: OleVariant);
    procedure NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
      const URL: OleVariant);
    {$IFEND}

    function GetBaseHTMLCode: string;

    function AddLinkedComponent(GMObject: TGMObjects): Integer;
    procedure RemoveLinkedComponent(GMObject: TGMObjects);

    // ES: ejecuta la funcin JavaScript con los parmetros dados
    // EN: execute a function JavaScript with params
    function ExecuteScript(NameFunct, Params: string): Boolean;
    function ExistLinkedComponent(Id: Cardinal): Integer;

    procedure SetActive(const Value: Boolean);
    procedure SetIntervalEvents(const Value: Integer);
    procedure SetWebBrowser(const Value: TWebBrowser);
    procedure SetPrecision(const Value: Integer);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    function GetAPIUrl: string; override;

    procedure ChangeCenter(Sender: TObject);

    // ES: funciones de control
    // EN: control functions
    function Check: Boolean;
    function MapIsNull: Boolean;

    // ES: evento OnTimer que se le asignar al TTimer
    // EN: event OnTimer that will be assigned to TTimer
    procedure OnTimer(Sender: TObject); virtual;
    // ES: procedimiento que carga el cdigo base de la pgina web
    // EN: procedure that load the base code of the web page
    procedure LoadBaseWeb;

    procedure SetMapTypeId(MapTypeId: TMapTypeId); overload;
    procedure SetMapTypeId(const MapTypeId: string); overload;
    procedure SetZoom(Zoom: Integer);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;

    // ES: conversiones
    // EN: conversions
    function MapTypeIdToStr(MapTypeId: TMapTypeId): string;
    function StrToMapTypeId(MapTypeId: string): TMapTypeId;
    function TColorToStr(Color: TColor): string;
    function MapTypeIdsToStr(Delimiter: Char = ';'): string;
    function PositionToStr(Position: TControlPosition): string;
    function StrToPosition(Position: string): TControlPosition;
    function MapTypeControlStyleToStr(MapTypeControlStyle: TMapTypeControlStyle): string;
    function StrToMapTypeControlStyle(MapTypeControlStyle: string): TMapTypeControlStyle;
    function ScaleControlStyleToStr(ScaleControlStyle: TScaleControlStyle): string;
    function StrToScaleControlStyle(ScaleControlStyle: string): TScaleControlStyle;
    function ZoomControlStyleToStr(ZoomControlStyle: TZoomControlStyle): string;
    function StrToZoomControlStyle(ZoomControlStyle: string): TZoomControlStyle;

    // ES: funciones para la clase LatLngBounds
    // EN: functions for LatLngBounds class
    procedure LatLngBoundsSetBounds(SWLat, SWLng, NELat, NELng: Real); overload;
    procedure LatLngBoundsSetBounds(Bounds: TLatLngBounds); overload;
    function LatLngBoundsGetBounds: TLatLngBounds;
    function LatLngBoundsContains(LatLng: TLatLng): Boolean; overload;
    function LatLngBoundsContains(Lat, Lng: Real): Boolean; overload;
    function LatLngBoundsExtend(LatLng: TLatLng): TLatLngBounds; overload;
    function LatLngBoundsExtend(Lat, Lng: Real): TLatLngBounds; overload;
    function LatLngBoundsGetCenter: TLatLng;
    function LatLngBoundsToSpan: TLatLng;

    // ES: funciones para la clase Map
    // EN: function fot Map class
    function GetCenter: TLatLng;
    function GetMapTypeId: TMapTypeId;
    function GetZoom: Integer;
    procedure PanBy(x, y: Integer);
    procedure PanTo(LatLng: TLatLng); overload;
    procedure PanTo(const Lat, Lng: Real); overload;
    procedure SetCenter(LatLng: TLatLng); overload;
    procedure SetCenter(const Lat, Lng: Real); overload;

    // ES: funciones de impresin o para guardar
    // EN: print or save functions
    procedure PrintNoDialog;
    procedure PrintWithDialog;
    procedure PrintPreview;
    procedure PrintPageSetup;
    procedure SaveToJPGFile(FileName: TFileName = '');

    // ES: crea el mapa con las opciones especificadas
    // EN: create the map with the specified options
    procedure DoMap; virtual;
  published
    // ES: objeto TWebBrowser donde se mostrar la pgina
    // EN: TWebBrowser objetc where show the page
    property WebBrowser: TWebBrowser read FWebBrowser write SetWebBrowser;
    // ES: activa o desactiva el acceso al mapa
    // EN: active o deactive map access
    property Active: Boolean read FActive write SetActive;
    // ES: intervalo de tiempo para comprovar los eventos del mapa
    // EN: interval of time to check the events of map
    property IntervalEvents: Integer read FIntervalEvents write SetIntervalEvents;
    // ES: opciones de configucacin requeridas
    // EN: required configuration options
    property RequiredProp: TRequiredProp read FRequiredProp write FRequiredProp;
    // ES: opciones de configuracin visuales
    // EN: visual configuration options
    property VisualProp: TVisualProp read FVisualProp write FVisualProp;
    // ES: opciones de configuracin no visuales
    // EN: no visual configurations options
    property NonVisualProp: TNonVisualProp read FNonVisualProp write FNonVisualProp;
    // ES: precisin para los valores de latitud y longitud. 0 = Max precisin, 1..17 decimales de precisin
    // EN: precision for lat and long values. 0 = Max precision, 1..17 precision decimals
    property Precision: Integer read FPrecision write SetPrecision;
    // ES: propiedad de acceso a las capas de Google Maps
    // EN: property to access Google Maps layers
    property Layers: TLayers read FLayers write FLayers;
    // ES: eventos
    // EN: events
        // from map
        // ES: evento disparado despus de cargar la 1er pgina y despus de la carga de los mosaicos visibles
        // EN: event fired when the 1st page and the visible tiles have finished loading
    property AfterPageLoaded: TAfterPageLoaded read FAfterPageLoaded write FAfterPageLoaded;
    property OnBoundsChanged: TBoundsChanged read FOnBoundsChanged write FOnBoundsChanged;
    property OnCenterChanged: TLatLngEvent read FOnCenterChanged write FOnCenterChanged;
    property OnClick: TLatLngEvent read FOnClick write FOnClick;
    property OnDblClick: TLatLngEvent read FOnDblClick write FOnDblClick;
    property OnDrag: TNotifyEvent read FOnDrag write FOnDrag;
    property OnDragEnd: TNotifyEvent read FOnDragEnd write FOnDragEnd;
    property OnDragStart: TNotifyEvent read FOnDragStart write FOnDragStart;
    property OnMapTypeIdChanged: TMapTypeIdChanged read FOnMapTypeIdChanged write FOnMapTypeIdChanged;
    property OnMouseMove: TLatLngEvent read FOnMouseMove write FOnMouseMove;
    property OnMouseOut: TLatLngEvent read FOnMouseOut write FOnMouseOut;
    property OnMouseOver: TLatLngEvent read FOnMouseOver write FOnMouseOver;
    property OnRightClick: TLatLngEvent read FOnRightClick write FOnRightClick;
    property OnZoomChanged: TZoomChanged read FOnZoomChanged write FOnZoomChanged;
    property OnWeatherClick: TWeatherClick read FOnWeatherClick write FOnWeatherClick;
    property OnPanoramioClick: TPanoramioClick read FOnPanoramioClick write FOnPanoramioClick;
        // from properties
    property OnActiveChange: TNotifyEvent read FOnActiveChange write FOnActiveChange;
    property OnIntervalEventsChange: TNotifyEvent read FOnIntervalEventsChange write FOnIntervalEventsChange;
    property OnPrecisionChange: TNotifyEvent read FOnPrecisionChange write FOnPrecisionChange;
  end;

  TEventType = (etMarkerClick, etMarkerDblClick, etMarkerDrag, etMarkerDragEnd, etMarkerDragStart,
                etMarkerMouseDown, etMarkerMouseOut, etMarkerMouseOver, etMarkerMouseUp,
                etMarkerRightClick,
                etInfoWinCloseClick, etInfoWinCloseOBO, etInfoWinDisableAP,
                etInfoWinHTMLContent, etInfoWinMaxWidth, etPixelOffset,
                etPolylineClick, etPolylineDblClick, etPolylineMouseDown, etPolylineMouseMove,
                etPolylineMouseOut, etPolylineMouseOver, etPolylineMouseUp, etPolylineRightClick,
                etRectangleClick, etRectangleDblClick, etRectangleMouseDown, etRectangleMouseMove,
                etRectangleMouseOut, etRectangleMouseOver, etRectangleMouseUp, etRectangleRightClick,
                etRectangleBoundsChange,
                etCircleClick, etCircleDblClick, etCircleMouseDown, etCircleMouseMove,
                etCircleMouseOut, etCircleMouseOver, etCircleMouseUp, etCircleRightClick,
                etCircleCenterChange, etCircleRadiusChange,
                etDirectionsChanged
                );
  { ****************************************************************************
    ES: clase base para los componentes enlazados al mapa
    EN: base class for a linked components to map
  **************************************************************************** }
  { ****************************************************************************
    internal class
  **************************************************************************** }
  TGMObjects = class(TGMBase)
  private
    FIdxList: Cardinal;
    FMap: TGMMap;
  protected
    procedure SetIdxList(const Value: Cardinal); virtual;
    procedure SetMap(const Value: TGMMap); virtual;

    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    // ES: ejecuta un script de JavaScript desde la clase TMap
    // EN: execute a script of JavaScript from TMap class
    function ExecuteScript(NameFunct, Params: string): Boolean; virtual;
    // ES: borra los objetos del mapa
    // EN: delete objects from map
    procedure DeleteMapObjects; virtual; abstract;
    // ES: muestra los objetos en el mapa
    // EN: show objects into the map
    procedure ShowElements; virtual; abstract;
    // ES: recoge los eventos lanzados desde el mapa para este objeto
    // EN: collect events fired from the map for this object
    procedure EventFired(EventType: TEventType; Params: array of const); virtual; abstract;

    // ES: posicin en la lista FLinkedComponents de la clase TMap
    // EN: position in the list FLinkedComponents of TMap class
    property IdxList: Cardinal read FIdxList write SetIdxList;
  public
    destructor Destroy; override;
  published
    property Map: TGMMap read FMap write SetMap;
  end;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TLinkedComponents = class;
  TLinkedComponent = class(TCollectionItem)
  private
    FIdxList: Cardinal;
    FInfoWindow: TBaseInfoWindow;
    FTag: Integer;
    FFObject: TObject;
    FText: string;
    FShowInfoWinMouseOver: Boolean;
    procedure SetShowInfoWinMouseOver(const Value: Boolean);
  protected
    procedure SetIdxList(const Value: Cardinal); virtual;

    procedure OnHTMLContentChange(Sender: TObject);
    procedure OnDisableAutoPanChange(Sender: TObject);
    procedure OnMaxWidthChange(Sender: TObject);
    procedure OnPixelOffsetChange(Sender: TObject);
    procedure OnCloseOtherBeforeOpenChange(Sender: TObject);

    //function SetProperties(FunctionName, EventName, Params: string): Boolean;
    function SetProperty(FunctionName, EventName, Value: string; Quoted: Boolean = True): Boolean; overload;
    function SetProperty(FunctionName, EventName: string; Value: Boolean): Boolean; overload;
    function SetProperty(FunctionName, EventName: string; Value: Integer): Boolean; overload;
    function SetProperty(FunctionName, EventName: string; Value: Real): Boolean; overload;
    {$IF CompilerVersion < 20}  // ES: si la versin es inferior a D2009 - EN: if lower than D2009 version
    function SetColorProperty(FunctionName, EventName: string; Value: TColor): Boolean; overload;
    {$ELSE}
    function SetProperty(FunctionName, EventName: string; Value: TColor): Boolean; overload;
    {$IFEND}

    function GetDisplayName: string; override;

    function ChangeProperties: Boolean; virtual; abstract;

    // ES: propiedad IdxList de la clase TGMLinkedComponent. Slo para facilidad de uso interno
    // EN: property IdxList from TGMLinkedComponent class. Just for easy internal use
    property IdxList: Cardinal read FIdxList write SetIdxList;
    property InfoWindow: TBaseInfoWindow read FInfoWindow write FInfoWindow;
    property Text: string read FText write FText;
    property ShowInfoWinMouseOver: Boolean read FShowInfoWinMouseOver write SetShowInfoWinMouseOver;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;

    property FObject: TObject read FFObject write FFObject;
  published
    property Tag: Integer read FTag write FTag;
  end;

  TLinkedComponentClass = class of TLinkedComponent;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TLinkedComponents = class(TCollection)
  private
    function GetItems(I: Integer): TLinkedComponent;
    procedure SetItems(I: Integer; const Value: TLinkedComponent);
  protected
    FGMLinkedComponent: TGMLinkedComponent;

    function GetOwner: TPersistent; override;

    function Add: TLinkedComponent;                     // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    function Insert(Index: Integer): TLinkedComponent;  // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    procedure Delete(Index: Integer);                   // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    procedure Move(CurIndex, NewIndex: Integer);        // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent
    procedure Clear;                                    // ES: regenera todos los LinkedComponent - EN: reload all LinkedComponent

    property Items[I: Integer]: TLinkedComponent read GetItems write SetItems; default;
  public
    constructor Create(GMLinkedComponent: TGMLinkedComponent; ItemClass: TCollectionItemClass); virtual;

    procedure Assign(Source: TPersistent); override;
  end;

  TLinkedComponentsClass = class of TLinkedComponents;

  TLinkedComponentChange = procedure(Sender: TObject; Index: Integer; LinkedComponent: TLinkedComponent) of object;
  TLatLngIdxEvent = procedure(Sender: TObject; LatLng: TLatLng; Index: Integer; LinkedComponent: TLinkedComponent) of object;

  { ****************************************************************************
    internal class
  **************************************************************************** }
  TGMLinkedComponent = class(TGMObjects)
  private
    FVisualObjects: TLinkedComponents;
    FOnCloseClick: TLinkedComponentChange;
    FAutoUpdate: Boolean;
    FOnCloseOtherBeforeOpenChange: TLinkedComponentChange;
    FOnDisableAutoPanChange: TLinkedComponentChange;
    FOnMaxWidthChange: TLinkedComponentChange;
    FOnPixelOffsetChange: TLinkedComponentChange;
    FOnHTMLContentChange: TLinkedComponentChange;
  protected
    procedure SetIdxList(const Value: Cardinal); override;
    function GetItems(I: Integer): TLinkedComponent;

    // ES: control de errores lanzados desde JavaScript
    // EN: error control fired from JavaScript
    procedure ErrorControl; virtual;
    // ES: borra los objetos del mapa
    // EN: delete objects from map
    procedure DeleteMapObjects; override;
    // ES: recoge los eventos lanzados desde el mapa para este objeto
    // EN: collect events fired from the map for this object
    procedure EventFired(EventType: TEventType; Params: array of const); override;
    // ES: obtienen la classe de la coleccin que implementa
    // EN: obtains the collection class that implements
    function GetCollectionItemClass: TLinkedComponentClass; virtual;
    function GetCollectionClass: TLinkedComponentsClass; virtual;

    function GetCount: Integer;

    // ES/EN: TCollectionItems
    property Items[I: Integer]: TLinkedComponent read GetItems; default;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure Assign(Source: TPersistent); override;

    // ES: funciones para aadir, borrar y mover los TCollectionItems
    // EN: functions to add, delete and move the TCollectionItems
    function Add: TLinkedComponent;
    procedure Delete(Index: Integer);
    procedure Move(CurIndex, NewIndex: Integer);
    procedure Clear;

    property Count: Integer read GetCount;
    // ES/EN: TCollection
    property VisualObjects: TLinkedComponents read FVisualObjects write FVisualObjects;
  published
    // ES: si Active, modifica los objetos de forma automtica, sino, necesita recargar el mapa
    // EN: if Active, update objects automatically, if not, you need to reload map
    property AutoUpdate: Boolean read FAutoUpdate write FAutoUpdate;

    // ES/EN: eventos/events
    property OnCloseClick: TLinkedComponentChange read FOnCloseClick write FOnCloseClick;
    property OnHTMLContentChange: TLinkedComponentChange read FOnHTMLContentChange write FOnHTMLContentChange;
    property OnDisableAutoPanChange: TLinkedComponentChange read FOnDisableAutoPanChange write FOnDisableAutoPanChange;
    property OnMaxWidthChange: TLinkedComponentChange read FOnMaxWidthChange write FOnMaxWidthChange;
    property OnPixelOffsetChange: TLinkedComponentChange read FOnPixelOffsetChange write FOnPixelOffsetChange;
    property OnCloseOtherBeforeOpenChange: TLinkedComponentChange read FOnCloseOtherBeforeOpenChange write FOnCloseOtherBeforeOpenChange;
  end;

implementation

uses
  Forms, ActiveX, Controls, MSHTML, StrUtils, Windows, TypInfo, Dialogs,
  XMLIntf, XMLDoc,
  Lang, WebControl, GMMarker, GMPolyline, GMRectangle, GMCircle, GMFunctions,
  GMDirection;

{ TGMMap }
{$R ..\Resources\gmmapres.RES}

{$IF CompilerVersion < 22}
procedure TGMMap.BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
  var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
{$ELSE}
procedure TGMMap.BeforeNavigate2(ASender: TObject; const pDisp: IDispatch;
  const URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
{$IFEND}
begin
  CurDispatch := nil;
  FDocLoaded := False;
end;

function TGMMap.AddLinkedComponent(GMObject: TGMObjects): Integer;
begin
  FLinkedComponents.Add(GMObject);
  Inc(FCountLinkedCom);
  GMObject.IdxList := FCountLinkedCom;
  Result := FCountLinkedCom;
end;

procedure TGMMap.Assign(Source: TPersistent);
begin
  inherited;

  if Source is TGMMap then
  begin
    WebBrowser.Assign(TGMMap(Source).WebBrowser);
    Active := TGMMap(Source).Active;
    IntervalEvents := TGMMap(Source).IntervalEvents;
    RequiredProp.Assign(TGMMap(Source).RequiredProp);
    VisualProp.Assign(TGMMap(Source).VisualProp);
    NonVisualProp.Assign(TGMMap(Source).NonVisualProp);
    Layers.Assign(TGMMap(Source).Layers);
  end;
end;

function TGMMap.LatLngBoundsExtend(LatLng: TLatLng): TLatLngBounds;
const
  StrParams = '%s,%s';
var
  Params: string;
  WC: TWebControl;
begin
  Result := TLatLngBounds.Create;

  Params := Format(StrParams, [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]);
  if not ExecuteScript('LatLngBoundsExtend', Params) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.SW.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.SW.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
    Result.NE.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELat), Precision);
    Result.NE.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELng), Precision);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

function TGMMap.LatLngBoundsContains(LatLng: TLatLng): Boolean;
const
  StrParams = '%s,%s';
var
  Params: string;
  WC: TWebControl;
begin
  Result := False;

  Params := Format(StrParams, [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]);

  if not ExecuteScript('LatLngBoundsContains', Params) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result := WC.GetBoolField(LatLngBoundsForm, LatLngBoundsFormContains);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

function TGMMap.LatLngBoundsContains(Lat, Lng: Real): Boolean;
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    Result := LatLngBoundsContains(LatLng);
  finally
    FreeAndNil(LatLng);
  end;
end;

function TGMMap.LatLngBoundsExtend(Lat, Lng: Real): TLatLngBounds;
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    Result := LatLngBoundsExtend(LatLng);
  finally
    FreeAndNil(LatLng);
  end;
end;

function TGMMap.LatLngBoundsGetBounds: TLatLngBounds;
var
  WC: TWebControl;
begin
  Result := TLatLngBounds.Create;

  if not ExecuteScript('MapGetBounds', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.SW.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.SW.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
    Result.NE.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELat), Precision);
    Result.NE.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormNELng), Precision);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

function TGMMap.LatLngBoundsGetCenter: TLatLng;
var
  WC: TWebControl;
begin
  Result := TLatLng.Create;

  if not ExecuteScript('LatLngBoundsGetCenter', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.LatLngBoundsSetBounds(SWLat, SWLng, NELat, NELng: Real);
var
  LLB: TLatLngBounds;
begin
  LLB := TLatLngBounds.Create(ControlPrecision(SWLat, Precision),
                              ControlPrecision(SWLng, Precision),
                              ControlPrecision(NELat, Precision),
                              ControlPrecision(NELng, Precision));
  try
    LatLngBoundsSetBounds(LLB);
  finally
    FreeAndNil(LLB);
  end;
end;

procedure TGMMap.LatLngBoundsSetBounds(Bounds: TLatLngBounds);
const
  StrParams = '%s,%s,%s,%s';
var
  Params: string;
begin
  Params := Format(StrParams, [Bounds.SW.LatToStr(FPrecision), Bounds.SW.LngToStr(FPrecision),
                               Bounds.NE.LatToStr(FPrecision), Bounds.NE.LngToStr(FPrecision)]);
  ExecuteScript('MapSetBounds', Params);
end;

function TGMMap.LatLngBoundsToSpan: TLatLng;
var
  WC: TWebControl;
begin
  Result := TLatLng.Create;

  if not ExecuteScript('LatLngBoundsToSpan', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.Lat := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLat), Precision);
    Result.Lng := ControlPrecision(WC.GetFloatField(LatLngBoundsForm, LatLngBoundsFormSWLng), Precision);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.LoadBaseWeb;
var
  StringStream: TStringStream;
  PersistStreamInit: IPersistStreamInit;
  StreamAdapter: IStream;
begin
  if not Assigned(FWebBrowser) then Exit;
  // creacin del TStringStream con el string que contiene la pgina web
  StringStream := TStringStream.Create(GetBaseHTMLCode {MAPA_CODE});
  try
    // nos aseguramos de tener algn contenido en Document
    if not Assigned(FWebBrowser.Document) then FWebBrowser.Navigate('about:blank');

    // acceder a la interfaz IPersistStreamInit de Document
    if FWebBrowser.Document.QueryInterface(IPersistStreamInit, PersistStreamInit) = S_OK then
    begin
      // borrar datos actuales
      if PersistStreamInit.InitNew = S_OK then
      begin
        // creacin y inicializacin del IStream
        StreamAdapter:= TStreamAdapter.Create(StringStream);
        try
          Screen.Cursor := crHourGlass;
          // carga de la pgina web mediante IPersistStreamInit
          PersistStreamInit.Load(StreamAdapter);
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end;
  finally
    StringStream.Free;
  end;
end;

function TGMMap.MapIsNull: Boolean;
var
  WC: TWebControl;
begin
  WC := TWebControl.Create(FWebBrowser);
  try
    Result := WC.GetIntegerField(MapForm, MapFormMapIsNull, 1) = 1;
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

function TGMMap.MapTypeControlStyleToStr(
  MapTypeControlStyle: TMapTypeControlStyle): string;
begin
  Result := GetEnumName(TypeInfo(TMapTypeControlStyle), Ord(MapTypeControlStyle));
end;

function TGMMap.MapTypeIdsToStr(Delimiter: Char): string;
begin
  Result := '';

  if mtHYBRID in VisualProp.MapTypeCtrl.MapTypeIds then
    Result := Result + 'mtHYBRID';

  if mtROADMAP in VisualProp.MapTypeCtrl.MapTypeIds then
  begin
    if Result <> '' then Result := Result + Delimiter;
    Result := Result + 'mtROADMAP';
  end;

  if mtSATELLITE in VisualProp.MapTypeCtrl.MapTypeIds then
  begin
    if Result <> '' then Result := Result + Delimiter;
    Result := Result + 'mtSATELLITE';
  end;

  if mtTERRAIN in VisualProp.MapTypeCtrl.MapTypeIds then
  begin
    if Result <> '' then Result := Result + Delimiter;
    Result := Result + 'mtTERRAIN';
  end;
end;

function TGMMap.MapTypeIdToStr(MapTypeId: TMapTypeId): string;
begin
  Result := GetEnumName(TypeInfo(TMapTypeId), Ord(MapTypeId));
end;

procedure TGMMap.ChangeCenter(Sender: TObject);
begin
  if Assigned(FWebBrowser) and FActive and FDocLoaded and FIsDoMap and not FIsUpdating then
  begin
    FIsUpdating := True;
    SetCenter(RequiredProp.Center);

//    if Assigned(FOnCenterChanged) then
//      FOnCenterChanged(Self, RequiredProp.Center);
  end;
end;

function TGMMap.Check: Boolean;
begin
  if not Assigned(FWebBrowser) then
    raise Exception.Create(GetTranslateText('No se ha especificado el objeto WebBrowser', Language));

  if not FActive then
    raise Exception.Create(GetTranslateText('No est activo', Language));

  if not FDocLoaded then
    raise Exception.Create(GetTranslateText('Pgina inicial aun no cargada', Language));

  Result := not (csDesigning in ComponentState);
end;

constructor TGMMap.Create(AOwner: TComponent);
begin
  inherited;

  FDocLoaded := False;
  FIsDoMap := False;
  FLinkedComponents := TList.Create;
  FCountLinkedCom := 0;
  FIsUpdating := False;

  FActive := False;
  FTimer := TTimer.Create(Self);
  FTimer.Enabled := False;
  FTimer.Interval := 200;
  FTimer.OnTimer := OnTimer;
  FIntervalEvents := 200;
  FRequiredProp := TRequiredProp.Create(Self);
  FRequiredProp.Center.OnChange := ChangeCenter;
  FVisualProp := TVisualProp.Create;
  FNonVisualProp := TNonVisualProp.Create;
  FLayers := TLayers.Create(Self);
end;

destructor TGMMap.Destroy;
begin
  if Assigned(FTimer) then FreeAndNil(FTimer);
  if Assigned(FRequiredProp) then FreeAndNil(FRequiredProp);
  if Assigned(FVisualProp) then FreeAndNil(FVisualProp);
  if Assigned(FNonVisualProp) then FreeAndNil(FNonVisualProp);
  if Assigned(FLayers) then FreeAndNil(FLayers);

  if Assigned(FLinkedComponents) then FreeAndNil(FLinkedComponents);

  inherited;
end;

{$IF CompilerVersion < 22}
procedure TGMMap.DocumentComplete(ASender: TObject; const pDisp: IDispatch;
  var URL: OleVariant);
{$ELSE}
procedure TGMMap.DocumentComplete(ASender: TObject; const pDisp: IDispatch;
  const URL: OleVariant);
{$IFEND}
begin
  if (pDisp = CurDispatch) then  // si son iguales, la pgina se ha cargado
  begin
    FDocLoaded := True;
    CurDispatch := nil;
    if FActive and Assigned(AfterPageLoaded) then AfterPageLoaded(Self, True);
  end;
end;

procedure TGMMap.DoMap;
const
  StrParams = '%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s';
var
  Params: String;
  i: Integer;
begin
  FIsDoMap := False;
  Params := Format(StrParams, [
             // required property
             RequiredProp.Center.LatToStr(FPrecision),                          // center -> lat
             RequiredProp.Center.LngToStr(FPrecision),                          // center -> lng
             QuotedStr(MapTypeIdToStr(RequiredProp.MapType)),                   // mapTypeId
             IntToStr(RequiredProp.Zoom),                                       // zoom
             // non visual property
             LowerCase(BoolToStr(DisableDoubleClickZoom in NonVisualProp.Options, True)), // disableDoubleClickZoom
             LowerCase(BoolToStr(Draggable in NonVisualProp.Options, True)),              // draggable
             LowerCase(BoolToStr(KeyboardShortcuts in NonVisualProp.Options, True)),      // keyboardShortcuts
             LowerCase(BoolToStr(NoClear in NonVisualProp.Options, True)),                // noClear
             LowerCase(BoolToStr(ScrollWheel in NonVisualProp.Options, True)),            // scrollwheel
             IntToStr(NonVisualProp.MaxZoom),                                             // maxZoom
             IntToStr(NonVisualProp.MinZoom),                                             // minZoom
             LowerCase(BoolToStr(NonVisualProp.MapMaker, True)),                          // mapMaker
             // visual property
             QuotedStr(TColorToStr(VisualProp.BGColor)),                        // backgroundColor
             LowerCase(BoolToStr(VisualProp.MapTypeCtrl.Show, True)),           // mapTypeControl
             QuotedStr(MapTypeIdsToStr(';')),                                   //   mapTypeIds
             QuotedStr(PositionToStr(VisualProp.MapTypeCtrl.Position)),         //   position
             QuotedStr(MapTypeControlStyleToStr(VisualProp.MapTypeCtrl.Style)), //   style
             LowerCase(BoolToStr(VisualProp.OverviewMapCtrl.Show, True)),       // overviewMapCtrl
             LowerCase(BoolToStr(VisualProp.OverviewMapCtrl.Opened, True)),     //   opened
             LowerCase(BoolToStr(VisualProp.PanCtrl.Show, True)),               // PanCtrl
             QuotedStr(PositionToStr(VisualProp.PanCtrl.Position)),             //   position
             LowerCase(BoolToStr(VisualProp.RotateCtrl.Show, True)),            // rotateCtrl
             QuotedStr(PositionToStr(VisualProp.RotateCtrl.Position)),          //   position
             LowerCase(BoolToStr(VisualProp.ScaleCtrl.Show, True)),             // scaleCtrl
             QuotedStr(PositionToStr(VisualProp.ScaleCtrl.Position)),           //   position
             QuotedStr(ScaleControlStyleToStr(VisualProp.ScaleCtrl.Style)),     //   style
             LowerCase(BoolToStr(VisualProp.StreetViewCtrl.Show, True)),        // streetViewCtrl
             QuotedStr(PositionToStr(VisualProp.StreetViewCtrl.Position)),      //   position
             LowerCase(BoolToStr(VisualProp.ZoomCtrl.Show, True)),              // zoomCtrl
             QuotedStr(PositionToStr(VisualProp.ZoomCtrl.Position)),            //   position
             QuotedStr(ZoomControlStyleToStr(VisualProp.ZoomCtrl.Style)),       //   style
             // layers
             LowerCase(BoolToStr(Layers.Traffic.Show, True)),
             LowerCase(BoolToStr(Layers.Transit.Show, True)),
             LowerCase(BoolToStr(Layers.Bicycling.Show, True)),
             LowerCase(BoolToStr(Layers.Panoramio.Show, True)),
             LowerCase(BoolToStr(Layers.Panoramio.Clickable, True)),
             LowerCase(BoolToStr(Layers.Panoramio.Filtered, True)),
             QuotedStr(GetConvertedString(Layers.Panoramio.FilterTag)),
             QuotedStr(GetConvertedString(Layers.Panoramio.FilterUserId)),
             LowerCase(BoolToStr(Layers.Weather.Show, True)),
             LowerCase(BoolToStr(Layers.Weather.Clickable, True)),
             LowerCase(BoolToStr(Layers.Weather.SuppressInfoWindows, True)),
             QuotedStr(TTransform.LabelColorToStr(Layers.Weather.LabelColor)),
             QuotedStr(TTransform.TemperatureUnitToStr(Layers.Weather.TemperatureUnit)),
             QuotedStr(TTransform.WindSpeedUnitToStr(Layers.Weather.WindSpeedUnit))
             ]);
  if not ExecuteScript('DoMap', Params) then Exit;
  FIsDoMap := True;

  // mostramos elementos de los componntes linkados
  // show elements from linked components
  for i := 0 to FLinkedComponents.Count - 1 do
    if TGMLinkedComponent(FLinkedComponents[i]).AutoUpdate then
      TGMLinkedComponent(FLinkedComponents[i]).ShowElements;
end;

function TGMMap.ExecuteScript(NameFunct, Params: string): Boolean;
var
  Doc2: IHTMLDocument2;
  Win2: IHTMLWindow2;
begin
  Result := Check;

  if not Result then Exit;

  Doc2 := FWebBrowser.Document as IHTMLDocument2;
  Win2 := Doc2.parentWindow;

  Win2.execScript(NameFunct + '(' + Params + ')', 'JavaScript');

  if MapIsNull then
    raise Exception.Create(GetTranslateText('El mapa todava no ha sido creado', Language));
end;

function TGMMap.ExistLinkedComponent(Id: Cardinal): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := 0 to FLinkedComponents.Count - 1 do
  begin
    if TGMLinkedComponent(FLinkedComponents[i]).IdxList = Id then
    begin
      Result := i;
      Break;
    end;
  end;
end;

function TGMMap.GetAPIUrl: string;
begin
  Result := 'https://developers.google.com/maps/documentation/javascript/reference?hl=en#Map';
end;

function TGMMap.GetBaseHTMLCode: string;
var
  List: TStringList;
  Stream: TResourceStream;
begin
  Result := '';
  
  List := TStringList.Create;
  try
    try
      Stream := TResourceStream.Create(HInstance, RES_MAPA_CODE, RT_RCDATA);
      List.LoadFromStream(Stream);
      Result := List.Text;
    finally
      if Assigned(Stream) then FreeAndNil(Stream);
      if Assigned(List) then FreeAndNil(List);
    end;
  except
    raise Exception.Create(GetTranslateText('No se ha podido cargar el recurso', Language));
  end;
end;

function TGMMap.GetCenter: TLatLng;
var
  WC: TWebControl;
begin
  Result := TLatLng.Create;

  if not ExecuteScript('MapGetCenter', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result.Lat := ControlPrecision(WC.GetFloatField(MapForm, MapFormLat), Precision);
    Result.Lng := ControlPrecision(WC.GetFloatField(MapForm, MapFormLng), Precision);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

function TGMMap.GetMapTypeId: TMapTypeId;
var
  WC: TWebControl;
begin
  Result := mtROADMAP;

  if not ExecuteScript('MapGetMapType', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result := StrToMapTypeId(WC.GetStringField(MapForm, MapFormMapTypeId));
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

function TGMMap.GetZoom: Integer;
var
  WC: TWebControl;
begin
  Result := 0;

  if not ExecuteScript('MapGetZoom(', '') then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    Result := WC.GetIntegerField(MapForm, MapFormZoom);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

{$IF CompilerVersion < 22}
procedure TGMMap.NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
  var URL: OleVariant);
{$ELSE}
procedure TGMMap.NavigateComplete2(ASender: TObject; const pDisp: IDispatch;
  const URL: OleVariant);
{$IFEND}
begin
  if CurDispatch = nil then
    CurDispatch := pDisp;
end;

procedure TGMMap.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;

  if (Operation = opRemove) and (AComponent <> nil) then
    if AComponent = FWebBrowser then
    begin
      FWebBrowser.OnBeforeNavigate2 := OldBeforeNavigate2;
      FWebBrowser.OnDocumentComplete := OldDocumentComplete;
      FWebBrowser.OnNavigateComplete2 := OldNavigateComplete2;

      OldBeforeNavigate2 := nil;
      OldDocumentComplete := nil;
      OldNavigateComplete2 := nil;

      FWebBrowser := nil;
    end;
end;

procedure TGMMap.OnTimer(Sender: TObject);
var
  MapEvents: TEventsMapForm;
  MarkerEvents: TEventsMarkerForm;
  InfoWinEvents: TEventsInfoWindowForm;
  PolylineEvents: TEventsPolylineForm;
  RectangleEvents: TEventsRectangleForm;
  CircleEvents: TEventsCircleForm;
  DirectionEvents: TEventsDirectionForm;
  EventFired: TEventsFired;

  procedure GetFormFields(WC: TWebControl);
  begin
    // map
    MapEvents.BoundsChanged := WC.GetBoolField(EventsMapForm, EventsFormBoundsChange);
    MapEvents.CenterChanged := WC.GetBoolField(EventsMapForm, EventsFormCenterChange);
    MapEvents.Click := WC.GetBoolField(EventsMapForm, EventsFormClick);
    MapEvents.DblClick := WC.GetBoolField(EventsMapForm, EventsFormDblClick);
    MapEvents.Drag := WC.GetBoolField(EventsMapForm, EventsFormDrag);
    MapEvents.DragEnd := WC.GetBoolField(EventsMapForm, EventsFormDragEnd);
    MapEvents.DragStart := WC.GetBoolField(EventsMapForm, EventsFormDragStart);
    MapEvents.MapTypeIdChanged := WC.GetBoolField(EventsMapForm, EventsFormMapTypeIdChanged);
    MapEvents.MouseMove := WC.GetBoolField(EventsMapForm, EventsFormMouseMove);
    MapEvents.MouseOut := WC.GetBoolField(EventsMapForm, EventsFormMouseOut);
    MapEvents.MouseOver := WC.GetBoolField(EventsMapForm, EventsFormMouseOver);
    MapEvents.RightClick := WC.GetBoolField(EventsMapForm, EventsFormRightClick);
    MapEvents.TilesLoaded := WC.GetBoolField(EventsMapForm, EventsFormTilesLoaded);
    MapEvents.ZoomChanged := WC.GetBoolField(EventsMapForm, EventsFormZoomChanged);
    MapEvents.SWLat := WC.GetFloatField(EventsMapForm, EventsFormSWLat);
    MapEvents.SWLng := WC.GetFloatField(EventsMapForm, EventsFormSWLng);
    MapEvents.NELat := WC.GetFloatField(EventsMapForm, EventsFormNELat);
    MapEvents.NELng := WC.GetFloatField(EventsMapForm, EventsFormNELng);
    MapEvents.Lat := WC.GetFloatField(EventsMapForm, EventsFormLat);
    MapEvents.Lng := WC.GetFloatField(EventsMapForm, EventsFormLng);
    MapEvents.X := WC.GetFloatField(EventsMapForm, EventsFormX);
    MapEvents.Y := WC.GetFloatField(EventsMapForm, EventsFormY);
    MapEvents.MapTypeId := WC.GetStringField(EventsMapForm, EventsFormMapTypeId);
    MapEvents.Zoom := WC.GetIntegerField(EventsMapForm, EventsFormZoom);
    MapEvents.WeatherClick := WC.GetBoolField(EventsMapForm, EventsFormWeatherClick);
    MapEvents.WeatherLat := WC.GetFloatField(EventsMapForm, EventsFormWeatherLat);
    MapEvents.WeatherLng := WC.GetFloatField(EventsMapForm, EventsFormWeatherLng);
    MapEvents.WeatherFeature := WC.GetStringField(EventsMapForm, EventsFormWeatherFeature);
    MapEvents.PanoClick := WC.GetBoolField(EventsMapForm, EventsFormPanoClick);
    MapEvents.PanoLat := WC.GetFloatField(EventsMapForm, EventsFormPanoLat);
    MapEvents.PanoLng := WC.GetFloatField(EventsMapForm, EventsFormPanoLng);
    MapEvents.PanoAuthor := WC.GetStringField(EventsMapForm, EventsFormPanoAuthor);
    MapEvents.PanoPhotoId := WC.GetStringField(EventsMapForm, EventsFormPanoPhotoId);
    MapEvents.PanoTitle := WC.GetStringField(EventsMapForm, EventsFormPanoTitle);
    MapEvents.PanoUrl := WC.GetStringField(EventsMapForm, EventsFormPanoUrl);
    MapEvents.PanoUserId := WC.GetStringField(EventsMapForm, EventsFormPanoUserId);
    // marker
    MarkerEvents.LinkCompId := WC.GetIntegerField(EventsMarkerForm, EventsFormLinkCompId);
    MarkerEvents.LinkCompZIndex := WC.GetIntegerField(EventsMarkerForm, EventsFormLinkCompZIndex);
    MarkerEvents.Lat := WC.GetFloatField(EventsMarkerForm, EventsFormLat);
    MarkerEvents.Lng := WC.GetFloatField(EventsMarkerForm, EventsFormLng);
    MarkerEvents.Click := WC.GetBoolField(EventsMarkerForm, EventsFormClick);
    MarkerEvents.DblClick := WC.GetBoolField(EventsMarkerForm, EventsFormDblClick);
    MarkerEvents.Drag := WC.GetBoolField(EventsMarkerForm, EventsFormDrag);
    MarkerEvents.DragEnd := WC.GetBoolField(EventsMarkerForm, EventsFormDragEnd);
    MarkerEvents.DragStart := WC.GetBoolField(EventsMarkerForm, EventsFormDragStart);
    MarkerEvents.MouseDown := WC.GetBoolField(EventsMarkerForm, EventsFormMouseDown);
    MarkerEvents.MouseOut := WC.GetBoolField(EventsMarkerForm, EventsFormMouseOut);
    MarkerEvents.MouseOver := WC.GetBoolField(EventsMarkerForm, EventsFormMouseOver);
    MarkerEvents.MouseUp := WC.GetBoolField(EventsMarkerForm, EventsFormMouseUp);
    MarkerEvents.RightClick := WC.GetBoolField(EventsMarkerForm, EventsFormRightClick);
    // InfoWindow
    InfoWinEvents.LinkCompId := WC.GetIntegerField(EventsInfoWinForm, EventsFormLinkCompId);
    InfoWinEvents.LinkCompZIndex := WC.GetIntegerField(EventsInfoWinForm, EventsFormLinkCompZIndex);
    InfoWinEvents.InfoWinCloseClick := WC.GetBoolField(EventsInfoWinForm, EventsFormInfoWinCloseClick);
    // Polyline
    PolylineEvents.LinkCompId := WC.GetIntegerField(EventsPolylineForm, EventsFormLinkCompId);
    PolylineEvents.LinkCompZIndex := WC.GetIntegerField(EventsPolylineForm, EventsFormLinkCompZIndex);
    PolylineEvents.Lat := WC.GetFloatField(EventsPolylineForm, EventsFormLat);
    PolylineEvents.Lng := WC.GetFloatField(EventsPolylineForm, EventsFormLng);
    PolylineEvents.Click := WC.GetBoolField(EventsPolylineForm, EventsFormClick);
    PolylineEvents.DblClick := WC.GetBoolField(EventsPolylineForm, EventsFormDblClick);
    PolylineEvents.MouseDown := WC.GetBoolField(EventsPolylineForm, EventsFormMouseDown);
    PolylineEvents.MouseMove := WC.GetBoolField(EventsPolylineForm, EventsFormMouseMove);
    PolylineEvents.MouseOut := WC.GetBoolField(EventsPolylineForm, EventsFormMouseOut);
    PolylineEvents.MouseOver := WC.GetBoolField(EventsPolylineForm, EventsFormMouseOver);
    PolylineEvents.MouseUp := WC.GetBoolField(EventsPolylineForm, EventsFormMouseUp);
    PolylineEvents.RightClick := WC.GetBoolField(EventsPolylineForm, EventsFormRightClick);
    // Rectangle
    RectangleEvents.LinkCompId := WC.GetIntegerField(EventsRectangleForm, EventsFormLinkCompId);
    RectangleEvents.LinkCompZIndex := WC.GetIntegerField(EventsRectangleForm, EventsFormLinkCompZIndex);
    RectangleEvents.Lat := WC.GetFloatField(EventsRectangleForm, EventsFormLat);
    RectangleEvents.Lng := WC.GetFloatField(EventsRectangleForm, EventsFormLng);
    RectangleEvents.NELat := WC.GetFloatField(EventsRectangleForm, EventsFormNELat);
    RectangleEvents.NELng := WC.GetFloatField(EventsRectangleForm, EventsFormNELng);
    RectangleEvents.SWLat := WC.GetFloatField(EventsRectangleForm, EventsFormSWLat);
    RectangleEvents.SWLng := WC.GetFloatField(EventsRectangleForm, EventsFormSWLng);
    RectangleEvents.BoundsChange := WC.GetBoolField(EventsRectangleForm, EventsFormBoundsChange);
    RectangleEvents.Click := WC.GetBoolField(EventsRectangleForm, EventsFormClick);
    RectangleEvents.DblClick := WC.GetBoolField(EventsRectangleForm, EventsFormDblClick);
    RectangleEvents.MouseDown := WC.GetBoolField(EventsRectangleForm, EventsFormMouseDown);
    RectangleEvents.MouseMove := WC.GetBoolField(EventsRectangleForm, EventsFormMouseMove);
    RectangleEvents.MouseOut := WC.GetBoolField(EventsRectangleForm, EventsFormMouseOut);
    RectangleEvents.MouseOver := WC.GetBoolField(EventsRectangleForm, EventsFormMouseOver);
    RectangleEvents.MouseUp := WC.GetBoolField(EventsRectangleForm, EventsFormMouseUp);
    RectangleEvents.RightClick := WC.GetBoolField(EventsRectangleForm, EventsFormRightClick);
    // Circle
    CircleEvents.LinkCompId := WC.GetIntegerField(EventsCircleForm, EventsFormLinkCompId);
    CircleEvents.LinkCompZIndex := WC.GetIntegerField(EventsCircleForm, EventsFormLinkCompZIndex);
    CircleEvents.Lat := WC.GetFloatField(EventsCircleForm, EventsFormLat);
    CircleEvents.Lng := WC.GetFloatField(EventsCircleForm, EventsFormLng);
    CircleEvents.Radius := WC.GetFloatField(EventsCircleForm, EventsFormCircleRadius);
    CircleEvents.CenterChange := WC.GetBoolField(EventsCircleForm, EventsFormCenterChange);
    CircleEvents.RadiusChange := WC.GetBoolField(EventsCircleForm, EventsFormCircleRadiusChange);
    CircleEvents.Click := WC.GetBoolField(EventsCircleForm, EventsFormClick);
    CircleEvents.DblClick := WC.GetBoolField(EventsCircleForm, EventsFormDblClick);
    CircleEvents.MouseDown := WC.GetBoolField(EventsCircleForm, EventsFormMouseDown);
    CircleEvents.MouseMove := WC.GetBoolField(EventsCircleForm, EventsFormMouseMove);
    CircleEvents.MouseOut := WC.GetBoolField(EventsCircleForm, EventsFormMouseOut);
    CircleEvents.MouseOver := WC.GetBoolField(EventsCircleForm, EventsFormMouseOver);
    CircleEvents.MouseUp := WC.GetBoolField(EventsCircleForm, EventsFormMouseUp);
    CircleEvents.RightClick := WC.GetBoolField(EventsCircleForm, EventsFormRightClick);
    // Direction
    DirectionEvents.LinkCompId := WC.GetIntegerField(EventsDirectionForm, EventsFormLinkCompId);
    DirectionEvents.LinkCompZIndex := WC.GetIntegerField(EventsDirectionForm, EventsFormLinkCompZIndex);
    DirectionEvents.XML := WC.GetStringField(EventsDirectionForm, EventsFormXML);
    DirectionEvents.DirectionsChanged := WC.GetBoolField(EventsDirectionForm, EventsFormDirectionsChanged);
  end;

  procedure InitializeFlags(WC: TWebControl);
  begin
    // map
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormZoomChanged, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormTilesLoaded, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormRightClick, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormMouseOver, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormMouseOut, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormMouseMove, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormMapTypeIdChanged, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormDragStart, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormDragEnd, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormDrag, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormDblClick, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormClick, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormCenterChange, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormBoundsChange, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormWeatherClick, '0');
    WC.WebFormSetFieldValue(EventsMapForm, EventsFormPanoClick, '0');
    // marker
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormLinkCompId, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormLinkCompZIndex, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormClick, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormDblClick, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormDrag, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormDragEnd, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormDragStart, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormMouseDown, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormMouseOut, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormMouseOver, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormMouseUp, '0');
    WC.WebFormSetFieldValue(EventsMarkerForm, EventsFormRightClick, '0');
    // InfoWindow
    WC.WebFormSetFieldValue(EventsInfoWinForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsInfoWinForm, EventsFormLinkCompId, '0');
    WC.WebFormSetFieldValue(EventsInfoWinForm, EventsFormLinkCompZIndex, '0');
    WC.WebFormSetFieldValue(EventsInfoWinForm, EventsFormInfoWinCloseClick, '0');
    // polyline
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormLinkCompId, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormLinkCompZIndex, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormClick, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormDblClick, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormMouseDown, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormMouseMove, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormMouseOut, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormMouseOver, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormMouseUp, '0');
    WC.WebFormSetFieldValue(EventsPolylineForm, EventsFormRightClick, '0');
    // rectangle
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormLinkCompId, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormLinkCompZIndex, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormBoundsChange, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormClick, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormDblClick, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormMouseDown, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormMouseMove, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormMouseOut, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormMouseOver, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormMouseUp, '0');
    WC.WebFormSetFieldValue(EventsRectangleForm, EventsFormRightClick, '0');
    // circle
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormLinkCompId, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormLinkCompZIndex, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormCenterChange, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormCircleRadiusChange, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormClick, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormDblClick, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormMouseDown, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormMouseMove, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormMouseOut, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormMouseOver, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormMouseUp, '0');
    WC.WebFormSetFieldValue(EventsCircleForm, EventsFormRightClick, '0');
    // direction
    WC.WebFormSetFieldValue(EventsDirectionForm, EventsFormEventFired, '0');
    WC.WebFormSetFieldValue(EventsDirectionForm, EventsFormLinkCompId, '0');
    WC.WebFormSetFieldValue(EventsDirectionForm, EventsFormLinkCompZIndex, '0');
    WC.WebFormSetFieldValue(EventsDirectionForm, EventsFormDirectionsChanged, '0');
  end;

  function GetEventsFired(var EF: TEventsFired): Boolean;
  var
    WC: TWebControl;
  begin
    WC := TWebControl.Create(FWebBrowser);
    try
      EF.Map := WC.GetIntegerField(EventsMapForm, EventsFormEventFired) = 1;
      EF.InfoWin := WC.GetIntegerField(EventsInfoWinForm, EventsFormEventFired) = 1;
      EF.Marker := WC.GetIntegerField(EventsMarkerForm, EventsFormEventFired) = 1;
      EF.Polyline := WC.GetIntegerField(EventsPolylineForm, EventsFormEventFired) = 1;
      EF.Rectangle := WC.GetIntegerField(EventsRectangleForm, EventsFormEventFired) = 1;
      EF.Circle := WC.GetIntegerField(EventsCircleForm, EventsFormEventFired) = 1;
      EF.Direction := WC.GetIntegerField(EventsDirectionForm, EventsFormEventFired) = 1;

      // cogemos campos del formulario // get form fields
      GetFormFields(WC);
      // inicializamos banderas // initialize flags
      InitializeFlags(WC);
    finally
      if Assigned(WC) then FreeAndNil(WC);
    end;

    Result := EF.Map or EF.InfoWin or EF.Marker or EF.Polyline or EF.Rectangle or EF.Circle;
  end;

  procedure MapEvent;
  var
    LLB: TLatLngBounds;
    LL: TLatLng;
    Weather: TWeatherFeature;
    Pano: TPanoramioFeature;
  begin
    // Map bounds_changed
    if MapEvents.BoundsChanged and Assigned(FOnBoundsChanged) then
    begin
      LLB := TLatLngBounds.Create(
                      ControlPrecision(MapEvents.SWLat, Precision),
                      ControlPrecision(MapEvents.SWLng, Precision),
                      ControlPrecision(MapEvents.NELat, Precision),
                      ControlPrecision(MapEvents.NELng, Precision));
      try
        FOnBoundsChanged(Self, LLB);
      finally
        FreeAndNil(LLB);
      end;
    end;

    // Map center_changed, click, dblclick, mousemove, mouseout, mouseover, rightclick
    if MapEvents.CenterChanged or MapEvents.Click or MapEvents.DblClick or MapEvents.MouseMove or
       MapEvents.MouseOut or MapEvents.MouseOver or MapEvents.RightClick then
    begin
      LL := TLatLng.Create(ControlPrecision(MapEvents.Lat, Precision), ControlPrecision(MapEvents.Lng, Precision));
      try
        if MapEvents.CenterChanged then
        begin
          if not FIsUpdating then
          begin
            FIsUpdating := True;
            FRequiredProp.Center.Assign(LL);
          end;
          FIsUpdating := False;
          if Assigned(FOnCenterChanged) then FOnCenterChanged(Self, LL, MapEvents.X, MapEvents.Y);
        end;
        if MapEvents.Click and Assigned(FOnClick) then FOnClick(Self, LL, MapEvents.X, MapEvents.Y);
        if MapEvents.DblClick and Assigned(FOnDblClick) then FOnDblClick(Self, LL, MapEvents.X, MapEvents.Y);
        if MapEvents.MouseMove and Assigned(FOnMouseMove) then FOnMouseMove(Self, LL, MapEvents.X, MapEvents.Y);
        if MapEvents.MouseOut and Assigned(FOnMouseOut) then FOnMouseOut(Self, LL, MapEvents.X, MapEvents.Y);
        if MapEvents.MouseOver and Assigned(FOnMouseOver) then FOnMouseOver(Self, LL, MapEvents.X, MapEvents.Y);
        if MapEvents.RightClick and Assigned(FOnRightClick) then FOnRightClick(Self, LL, MapEvents.X, MapEvents.Y);
      finally
        FreeAndNil(LL);
      end;
    end;

    // Map drag, dargend, dragstart
    if MapEvents.Drag and Assigned(FOnDrag) then FOnDrag(Self);
    if MapEvents.DragEnd then
    begin
      FRequiredProp.Center.Assign(GetCenter);
      if Assigned(FOnDragEnd) then FOnDragEnd(Self);
    end;
    if MapEvents.DragStart and Assigned(FOnDragStart) then FOnDragStart(Self);

    // Map MapTypeIdChanged
    if MapEvents.MapTypeIdChanged then
    begin
      if not FIsUpdating then
      begin
        FIsUpdating := True;
        FRequiredProp.MapType := StrToMapTypeId(MapEvents.MapTypeId);
        if Assigned(FOnMapTypeIdChanged) then FOnMapTypeIdChanged(Self, RequiredProp.MapType);
      end;
      FIsUpdating := False;
    end;

    // Map TilesLoaded
    if MapEvents.TilesLoaded and Assigned(FAfterPageLoaded) then AfterPageLoaded(Self, False);

    // Map ZoomChanged
    if MapEvents.ZoomChanged then
    begin
      if not FIsUpdating then
      begin
        FIsUpdating := True;
        FRequiredProp.Zoom := MapEvents.Zoom;
        if Assigned(FOnZoomChanged) then FOnZoomChanged(Self, MapEvents.Zoom);
      end;
      FIsUpdating := False;
    end;

    // Map WeatherClick
    if MapEvents.WeatherClick then
    begin
      LL := TLatLng.Create(ControlPrecision(MapEvents.WeatherLat, Precision), ControlPrecision(MapEvents.WeatherLng, Precision));
      Weather := TWeatherFeature.Create;
      Weather.ProcessXMLData(MapEvents.WeatherFeature);

      if Assigned(FOnWeatherClick) then FOnWeatherClick(Self, LL, Weather);
    end;

    // Map PanoramioClick
    if MapEvents.PanoClick then
    begin
      LL := TLatLng.Create(ControlPrecision(MapEvents.PanoLat, Precision), ControlPrecision(MapEvents.PanoLng, Precision));
      Pano := TPanoramioFeature.Create;
      Pano.FAuthor := MapEvents.PanoAuthor;
      Pano.FUserId := MapEvents.PanoUserId;
      Pano.FPhotoId := MapEvents.PanoPhotoId;
      Pano.FTitle := MapEvents.PanoTitle;
      Pano.FUrl := MapEvents.PanoUrl;

      if Assigned(FOnPanoramioClick) then FOnPanoramioClick(Self, LL, Pano);
    end;
  end;

  procedure MarkerEvent;
  var
    LinkComp: Integer;
  begin
    // Marker events
    if not MarkerEvents.Click and not MarkerEvents.DblClick and not MarkerEvents.Drag and
       not MarkerEvents.DragEnd and not MarkerEvents.DragStart and not MarkerEvents.MouseDown and
       not MarkerEvents.MouseOut and not MarkerEvents.MouseOver and not MarkerEvents.MouseUp and
       not MarkerEvents.RightClick then
      Exit;

    LinkComp := ExistLinkedComponent(MarkerEvents.LinkCompId);
    if LinkComp = -1 then
      raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

    if not (TGMLinkedComponent(FLinkedComponents[LinkComp]) is TGMMarker) then
      raise Exception.Create(GetTranslateText('Id de JavaScript incorrecto', Language));

    with TGMLinkedComponent(FLinkedComponents[LinkComp]), MarkerEvents do
    begin
      if Click then EventFired(etMarkerClick, [Lat, Lng, LinkCompZIndex]);
      if DblClick then EventFired(etMarkerDblClick, [Lat, Lng, LinkCompZIndex]);
      if Drag then EventFired(etMarkerDrag, [Lat, Lng, LinkCompZIndex]);
      if DragEnd then EventFired(etMarkerDragEnd, [Lat, Lng, LinkCompZIndex]);
      if DragStart then EventFired(etMarkerDragStart, [Lat, Lng, LinkCompZIndex]);
      if MouseDown then EventFired(etMarkerMouseDown, [Lat, Lng, LinkCompZIndex]);
      if MouseOut then EventFired(etMarkerMouseOut, [Lat, Lng, LinkCompZIndex]);
      if MouseOver then EventFired(etMarkerMouseOver, [Lat, Lng, LinkCompZIndex]);
      if MouseUp then EventFired(etMarkerMouseUp, [Lat, Lng, LinkCompZIndex]);
      if RightClick then EventFired(etMarkerRightClick, [Lat, Lng, LinkCompZIndex]);
    end;
  end;

  procedure InfoWindowEvent;
  var
    LinkComp: Integer;
  begin
    // InfoWindow events
    if not InfoWinEvents.InfoWinCloseClick then Exit;

    LinkComp := ExistLinkedComponent(InfoWinEvents.LinkCompId);
    if LinkComp = -1 then
      raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

    with TGMLinkedComponent(FLinkedComponents[LinkComp]), InfoWinEvents do
    begin
      if InfoWinCloseClick then EventFired(etInfoWinCloseClick, [LinkCompZIndex]);
    end;
  end;

  procedure PolylineEvent;
  var
    LinkComp: Integer;
  begin
    // Polyline and polygon events
    if not PolylineEvents.Click and not PolylineEvents.DblClick and not PolylineEvents.MouseDown and
       not PolylineEvents.MouseMove and not PolylineEvents.MouseOut and not PolylineEvents.MouseOver and
       not PolylineEvents.MouseUp and not PolylineEvents.RightClick then
      Exit;

    LinkComp := ExistLinkedComponent(PolylineEvents.LinkCompId);
    if LinkComp = -1 then
      raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

    if not (TGMLinkedComponent(FLinkedComponents[LinkComp]) is TGMBasePolyline) then
      raise Exception.Create(GetTranslateText('Id de JavaScript incorrecto', Language));

    with TGMLinkedComponent(FLinkedComponents[LinkComp]), PolylineEvents do
    begin
      if Click then EventFired(etPolylineClick, [Lat, Lng, LinkCompZIndex]);
      if DblClick then EventFired(etPolylineDblClick, [Lat, Lng, LinkCompZIndex]);
      if MouseDown then EventFired(etPolylineMouseDown, [Lat, Lng, LinkCompZIndex]);
      if MouseMove then EventFired(etPolylineMouseMove, [Lat, Lng, LinkCompZIndex]);
      if MouseOut then EventFired(etPolylineMouseOut, [Lat, Lng, LinkCompZIndex]);
      if MouseOver then EventFired(etPolylineMouseOver, [Lat, Lng, LinkCompZIndex]);
      if MouseUp then EventFired(etPolylineMouseUp, [Lat, Lng, LinkCompZIndex]);
      if RightClick then EventFired(etPolylineRightClick, [Lat, Lng, LinkCompZIndex]);
    end;
  end;

  procedure CheckAutoUpdatePath;
  var
    i, j: Integer;
  begin
    for i := 0 to FLinkedComponents.Count - 1 do
    begin
      if not (TGMLinkedComponent(FLinkedComponents[i]) is TGMBasePolyline) then Continue;

      for j := 0 to TGMBasePolyline(FLinkedComponents[i]).VisualObjects.Count - 1 do
      begin
        if TGMBasePolyline(FLinkedComponents[i])[j].AutoUpdatePath then
          TGMBasePolyline(FLinkedComponents[i])[j].GetPath;
      end;
    end;
  end;

  procedure RectangleEvent;
  var
    LinkComp: Integer;
  begin
    // Rectangle events
    if not RectangleEvents.Click and not RectangleEvents.DblClick and not RectangleEvents.MouseDown and
       not RectangleEvents.MouseMove and not RectangleEvents.MouseOut and not RectangleEvents.MouseOver and
       not RectangleEvents.MouseUp and not RectangleEvents.RightClick and not RectangleEvents.BoundsChange then
      Exit;

    LinkComp := ExistLinkedComponent(RectangleEvents.LinkCompId);
    if LinkComp = -1 then
      raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

    if not (TGMLinkedComponent(FLinkedComponents[LinkComp]) is TGMRectangle) then
      raise Exception.Create(GetTranslateText('Id de JavaScript incorrecto', Language));

    with TGMLinkedComponent(FLinkedComponents[LinkComp]), RectangleEvents do
    begin
      if Click then EventFired(etRectangleClick, [Lat, Lng, LinkCompZIndex]);
      if DblClick then EventFired(etRectangleDblClick, [Lat, Lng, LinkCompZIndex]);
      if MouseDown then EventFired(etRectangleMouseDown, [Lat, Lng, LinkCompZIndex]);
      if MouseMove then EventFired(etRectangleMouseMove, [Lat, Lng, LinkCompZIndex]);
      if MouseOut then EventFired(etRectangleMouseOut, [Lat, Lng, LinkCompZIndex]);
      if MouseOver then EventFired(etRectangleMouseOver, [Lat, Lng, LinkCompZIndex]);
      if MouseUp then EventFired(etRectangleMouseUp, [Lat, Lng, LinkCompZIndex]);
      if RightClick then EventFired(etRectangleRightClick, [Lat, Lng, LinkCompZIndex]);
      if BoundsChange then EventFired(etRectangleBoundsChange, [LinkCompZIndex, NELat, NELng, SWLat, SWLng]);
    end;
  end;

  procedure CircleEvent;
  var
    LinkComp: Integer;
  begin
    // Circle events
    if not CircleEvents.Click and not CircleEvents.DblClick and not CircleEvents.MouseDown and
       not CircleEvents.MouseMove and not CircleEvents.MouseOut and not CircleEvents.MouseOver and
       not CircleEvents.MouseUp and not CircleEvents.RightClick and not CircleEvents.CenterChange and
       not CircleEvents.RadiusChange then
      Exit;

    LinkComp := ExistLinkedComponent(CircleEvents.LinkCompId);
    if LinkComp = -1 then
      raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

    if not (TGMLinkedComponent(FLinkedComponents[LinkComp]) is TGMCircle) then
      raise Exception.Create(GetTranslateText('Id de JavaScript incorrecto', Language));

    with TGMLinkedComponent(FLinkedComponents[LinkComp]), CircleEvents do
    begin
      if Click then EventFired(etCircleClick, [Lat, Lng, LinkCompZIndex]);
      if DblClick then EventFired(etCircleDblClick, [Lat, Lng, LinkCompZIndex]);
      if MouseDown then EventFired(etCircleMouseDown, [Lat, Lng, LinkCompZIndex]);
      if MouseMove then EventFired(etCircleMouseMove, [Lat, Lng, LinkCompZIndex]);
      if MouseOut then EventFired(etCircleMouseOut, [Lat, Lng, LinkCompZIndex]);
      if MouseOver then EventFired(etCircleMouseOver, [Lat, Lng, LinkCompZIndex]);
      if MouseUp then EventFired(etCircleMouseUp, [Lat, Lng, LinkCompZIndex]);
      if RightClick then EventFired(etCircleRightClick, [Lat, Lng, LinkCompZIndex]);
      if RadiusChange then EventFired(etCircleRadiusChange, [Radius, LinkCompZIndex, CenterChange]);
      if CenterChange then EventFired(etCircleCenterChange, [Lat, Lng, LinkCompZIndex]);
    end;
  end;

  procedure DirectionEvent;
  var
    LinkComp: Integer;
  begin
    // Direction events
    if not DirectionEvents.DirectionsChanged then Exit;

    LinkComp := ExistLinkedComponent(DirectionEvents.LinkCompId);
    if LinkComp = -1 then
      raise Exception.Create(GetTranslateText('Id de JavaScript inexistente', Language));

    if not (TGMObjects(FLinkedComponents[LinkComp]) is TGMDirection) then
      raise Exception.Create(GetTranslateText('Id de JavaScript incorrecto', Language));

    with TGMDirection(FLinkedComponents[LinkComp]), DirectionEvents do
      if DirectionsChanged then EventFired(etDirectionsChanged, [XML, LinkCompZIndex]);
  end;
begin
  if csDesigning in ComponentState then Exit;
  if not Assigned(FWebBrowser) or not FDocLoaded or not FIsDoMap then Exit;

  if not GetEventsFired(EventFired) then Exit;

  // map events
  if EventFired.Map then MapEvent;

  // marker events
  if EventFired.Marker then MarkerEvent;

  // infoWindow event
  if EventFired.InfoWin then InfoWindowEvent;

  // polyline or polygon events
  if EventFired.Polyline then PolylineEvent;

  // check AutoUpdatePath
  CheckAutoUpdatePath;

  // rectangle events
  if EventFired.Rectangle then RectangleEvent;

  // circle events
  if EventFired.Circle then CircleEvent;

  // direction events
  if EventFired.Direction then DirectionEvent;
end;

procedure TGMMap.PanBy(x, y: Integer);
begin
  ExecuteScript('MapPanBy', Format('%s,%s', [IntToStr(x), IntToStr(y)]));
end;

procedure TGMMap.PanTo(LatLng: TLatLng);
begin
  ExecuteScript('MapPanTo', Format('%s,%s', [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]));
end;

procedure TGMMap.PanTo(const Lat, Lng: Real);
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    PanTo(LatLng);
  finally
    if Assigned(LatLng) then FreeAndNil(LatLng);
  end;
end;

function TGMMap.PositionToStr(Position: TControlPosition): string;
begin
  Result := GetEnumName(TypeInfo(TControlPosition), Ord(Position));
end;

procedure TGMMap.PrintNoDialog;
var
  WC: TWebControl;
begin
  if not Assigned(FWebBrowser) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    WC.WebPrintWithoutDialog;
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.PrintPageSetup;
var
  WC: TWebControl;
begin
  if not Assigned(FWebBrowser) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    WC.WebPrintPageSetup;
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.PrintPreview;
var
  WC: TWebControl;
begin
  if not Assigned(FWebBrowser) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    WC.WebPrintPreview;
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.PrintWithDialog;
var
  WC: TWebControl;
begin
  if not Assigned(FWebBrowser) then Exit;

  WC := TWebControl.Create(FWebBrowser);
  try
    WC.WebPrintWithDialog;
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.RemoveLinkedComponent(GMObject: TGMObjects);
begin
  if Assigned(FLinkedComponents) then
    FLinkedComponents.Remove(GMObject);
end;

function TGMMap.ScaleControlStyleToStr(
  ScaleControlStyle: TScaleControlStyle): string;
begin
  Result := GetEnumName(TypeInfo(TScaleControlStyle), Ord(ScaleControlStyle));
end;

procedure TGMMap.SaveToJPGFile(FileName: TFileName);
var
  SD: TSaveDialog;
  WC: TWebControl;
begin
  if not Assigned(FWebBrowser) then Exit;

  if FileName = '' then
  begin
    SD := TSaveDialog.Create(nil);
    try
      SD.Filter := '*.jpg|*.jpg';
      SD.DefaultExt := '*.jpg';
      if SD.Execute then FileName := SD.FileName;
    finally
      FreeAndNilProperties(SD);
    end;
  end;

  WC := TWebControl.Create(FWebBrowser);
  try
    WC.SaveToJPGFile(FileName);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;
end;

procedure TGMMap.SetActive(const Value: Boolean);
begin
  if FActive = Value then Exit;

  FActive := Value;

  if csDesigning in ComponentState then Exit;

  FTimer.Enabled := FActive;

  if Assigned(FWebBrowser) then
  begin
    if FActive then
      LoadBaseWeb
    else
      FWebBrowser.Navigate('about:blank');
  end;

  if Assigned(FOnActiveChange) then FOnActiveChange(Self);
end;

procedure TGMMap.SetCenter(LatLng: TLatLng);
begin
  if Assigned(LatLng) then
    ExecuteScript('MapSetCenter', Format('%s,%s', [LatLng.LatToStr(FPrecision), LatLng.LngToStr(FPrecision)]));
end;

procedure TGMMap.SetCenter(const Lat, Lng: Real);
var
  LatLng: TLatLng;
begin
  LatLng := TLatLng.Create(ControlPrecision(Lat, Precision), ControlPrecision(Lng, Precision));
  try
    SetCenter(LatLng);
  finally
    if Assigned(LatLng) then FreeAndNil(LatLng);
  end;
end;

procedure TGMMap.SetIntervalEvents(const Value: Integer);
begin
  if FIntervalEvents = Value then Exit;

  FIntervalEvents := Value;

  if Assigned(FTimer) then FTimer.Interval := FIntervalEvents;

  if Assigned(FOnIntervalEventsChange) then FOnIntervalEventsChange(Self);
end;

procedure TGMMap.SetMapTypeId(MapTypeId: TMapTypeId);
begin
  SetMapTypeId(MapTypeIdToStr(MapTypeId));
end;

procedure TGMMap.SetMapTypeId(const MapTypeId: string);
begin
  ExecuteScript('MapSetMapTypeId', QuotedStr(MapTypeId));
end;

procedure TGMMap.SetPrecision(const Value: Integer);
begin
  if FPrecision = Value then Exit;

  FPrecision := Value;

  if FPrecision < 0 then FPrecision := 0;
  if FPrecision > 17 then FPrecision := 17;

  if Assigned(FOnPrecisionChange) then FOnPrecisionChange(Self);
end;

procedure TGMMap.SetWebBrowser(const Value: TWebBrowser);
begin
  if FWebBrowser = Value then Exit;

  FWebBrowser := Value;

  if csDesigning in ComponentState then Exit;

  if Assigned(FWebBrowser) then
  begin
    OldBeforeNavigate2 := FWebBrowser.OnBeforeNavigate2;
    OldDocumentComplete := FWebBrowser.OnDocumentComplete;
    OldNavigateComplete2 := FWebBrowser.OnNavigateComplete2;

    FWebBrowser.OnBeforeNavigate2 := BeforeNavigate2;
    FWebBrowser.OnDocumentComplete := DocumentComplete;
    FWebBrowser.OnNavigateComplete2 := NavigateComplete2;

    if FActive then LoadBaseWeb;
  end;
end;

procedure TGMMap.SetZoom(Zoom: Integer);
begin
  ExecuteScript('MapSetZoom', IntToStr(Zoom));
end;

function TGMMap.StrToMapTypeControlStyle(
  MapTypeControlStyle: string): TMapTypeControlStyle;
begin
  Result := TMapTypeControlStyle(GetEnumValue(TypeInfo(TMapTypeControlStyle), MapTypeControlStyle));
end;

function TGMMap.StrToMapTypeId(MapTypeId: string): TMapTypeId;
begin
  Result := TMapTypeId(GetEnumValue(TypeInfo(TMapTypeId), MapTypeId));
end;

function TGMMap.StrToPosition(Position: string): TControlPosition;
begin
  Result := TControlPosition(GetEnumValue(TypeInfo(TControlPosition), Position));
end;

function TGMMap.StrToScaleControlStyle(
  ScaleControlStyle: string): TScaleControlStyle;
begin
  Result := TScaleControlStyle(GetEnumValue(TypeInfo(TScaleControlStyle), ScaleControlStyle));
end;

function TGMMap.StrToZoomControlStyle(
  ZoomControlStyle: string): TZoomControlStyle;
begin
  Result := TZoomControlStyle(GetEnumValue(TypeInfo(TZoomControlStyle), ZoomControlStyle));
end;

function TGMMap.TColorToStr(Color: TColor): string;
  function GetRValue(rgb: LongWord): Byte;
  begin
    Result := Byte(rgb);
  end;

  function GetGValue(rgb: LongWord): Byte;
  begin
    Result := Byte(rgb shr 8);
  end;

  function GetBValue(rgb: LongWord): Byte;
  begin
    Result := Byte(rgb shr 16);
  end;
var
  tmpRGB: LongWord;
begin
  tmpRGB := ColorToRGB(Color);
  Result := Format('#%.2x%.2x%.2x',
                   [GetRValue(tmpRGB),
                    GetGValue(tmpRGB),
                    GetBValue(tmpRGB)]);
end;

function TGMMap.ZoomControlStyleToStr(
  ZoomControlStyle: TZoomControlStyle): string;
begin
  Result := GetEnumName(TypeInfo(TZoomControlStyle), Ord(ZoomControlStyle));
end;

{ TRequiredProp }

procedure TRequiredProp.Assign(Source: TPersistent);
begin
  if Source is TRequiredProp then
  begin
    Center.Assign(TRequiredProp(Source).Center);
    MapType := TRequiredProp(Source).MapType;
    Zoom := TRequiredProp(Source).Zoom;
  end
  else
    inherited Assign(Source);
end;

constructor TRequiredProp.Create(GMMap: TGMMap);
begin
  FCenter := TLatLng.Create(0,0);
  FMapType := mtROADMAP;
  FZoom := 8;
  FGMMap := GMMap;
end;

destructor TRequiredProp.Destroy;
begin
  if Assigned(FCenter) then FreeAndNil(FCenter);

  inherited;
end;

procedure TRequiredProp.SetMapType(const Value: TMapTypeId);
begin
  if FMapType = Value then Exit;

  FMapType := Value;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap and not FGMMap.FIsUpdating then
  begin
    FGMMap.FIsUpdating := True;
    FGMMap.SetMapTypeId(FMapType);
    if Assigned(FGMMap.OnMapTypeIdChanged) then FGMMap.OnMapTypeIdChanged(FGMMap, FMapType);
  end;
end;

procedure TRequiredProp.SetZoom(const Value: Integer);
begin
  if FZoom = Value then Exit;

  FZoom := Value;
  if FZoom > 15 then FZoom := 15;
  if FZoom < 0 then FZoom := 0;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap and not FGMMap.FIsUpdating then
  begin
    FGMMap.FIsUpdating := True;
    FGMMap.SetZoom(FZoom);
    if Assigned(FGMMap.OnZoomChanged) then FGMMap.OnZoomChanged(FGMMap, FZoom);
  end;
end;

{ TVisualProp }

procedure TVisualProp.Assign(Source: TPersistent);
begin
  if Source is TVisualProp then
  begin
    MapTypeCtrl.Assign(TVisualProp(Source).MapTypeCtrl);
    OverviewMapCtrl.Assign(TVisualProp(Source).OverviewMapCtrl);
    PanCtrl.Assign(TVisualProp(Source).PanCtrl);
    RotateCtrl.Assign(TVisualProp(Source).RotateCtrl);
    ScaleCtrl.Assign(TVisualProp(Source).ScaleCtrl);
    StreetViewCtrl.Assign(TVisualProp(Source).StreetViewCtrl);
    ZoomCtrl.Assign(TVisualProp(Source).ZoomCtrl);
  end
  else
    inherited Assign(Source);
end;

constructor TVisualProp.Create;
begin
  FBGColor := $00EEF0EF;
  FMapTypeCtrl := TMapTypeControlOptions.Create;
  FOverviewMapCtrl := TOverviewMapControlOptions.Create;
  FPanCtrl := TPanControlOptions.Create;
  FRotateCtrl := TRotateControlOptions.Create;
  FScaleCtrl := TScaleControlOptions.Create;
  FStreetViewCtrl := TStreetViewControlOptions.Create;
  FZoomCtrl := TZoomControlOptions.Create;
end;

destructor TVisualProp.Destroy;
begin
  if Assigned(FMapTypeCtrl) then FreeAndNil(FMapTypeCtrl);
  if Assigned(FOverviewMapCtrl) then FreeAndNil(FOverviewMapCtrl);
  if Assigned(FPanCtrl) then FreeAndNil(FPanCtrl);
  if Assigned(FRotateCtrl) then FreeAndNil(FRotateCtrl);
  if Assigned(FScaleCtrl) then FreeAndNil(FScaleCtrl);
  if Assigned(FStreetViewCtrl) then FreeAndNil(FStreetViewCtrl);
  if Assigned(FZoomCtrl) then FreeAndNil(FZoomCtrl);

  inherited;
end;

{ TMapTypeControlOptions }

procedure TMapTypeControlOptions.Assign(Source: TPersistent);
begin
  if Source is TMapTypeControlOptions then
  begin
    MapTypeIds := TMapTypeControlOptions(Source).MapTypeIds;
    Position := TMapTypeControlOptions(Source).Position;
    Style := TMapTypeControlOptions(Source).Style;
    Show := TMapTypeControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TMapTypeControlOptions.Create;
begin
  FPosition := cpTOP_RIGHT;
  FStyle := mtcDEFAULT;
  FShow := True;
  FMapTypeIds := [mtHYBRID, mtROADMAP, mtSATELLITE, mtTERRAIN];
end;

{ TOverviewMapControlOptions }

procedure TOverviewMapControlOptions.Assign(Source: TPersistent);
begin
  if Source is TOverviewMapControlOptions then
  begin
    Opened := TOverviewMapControlOptions(Source).Opened;
    Show := TOverviewMapControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TOverviewMapControlOptions.Create;
begin
  FOpened := True;
  FShow := True;
end;

{ TPanControlOptions }

procedure TPanControlOptions.Assign(Source: TPersistent);
begin
  if Source is TPanControlOptions then
  begin
    Position := TPanControlOptions(Source).Position;
    Show := TPanControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TPanControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FShow := True;
end;

{ TRotateControlOptions }

procedure TRotateControlOptions.Assign(Source: TPersistent);
begin
  if Source is TRotateControlOptions then
  begin
    Position := TRotateControlOptions(Source).Position;
    Show := TRotateControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TRotateControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FShow := True;
end;

{ TScaleControlOptions }

procedure TScaleControlOptions.Assign(Source: TPersistent);
begin
  if Source is TScaleControlOptions then
  begin
    Position := TScaleControlOptions(Source).Position;
    Style := TScaleControlOptions(Source).Style;
    Show := TScaleControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TScaleControlOptions.Create;
begin
  FPosition := cpBOTTOM_LEFT;
  FStyle := scDEFAULT;
  FShow := True;
end;

{ TStreetViewControlOptions }

procedure TStreetViewControlOptions.Assign(Source: TPersistent);
begin
  if Source is TStreetViewControlOptions then
  begin
    Position := TStreetViewControlOptions(Source).Position;
    Show := TStreetViewControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TStreetViewControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FShow := True;
end;

{ TZoomControlOptions }

procedure TZoomControlOptions.Assign(Source: TPersistent);
begin
  if Source is TZoomControlOptions then
  begin
    Position := TZoomControlOptions(Source).Position;
    Style := TZoomControlOptions(Source).Style;
    Show := TZoomControlOptions(Source).Show;
  end
  else
    inherited Assign(Source);
end;

constructor TZoomControlOptions.Create;
begin
  FPosition := cpTOP_LEFT;
  FStyle := zcDEFAULT;
  FShow := True;
end;

{ TNonVisualProp }

procedure TNonVisualProp.Assign(Source: TPersistent);
begin
  if Source is TNonVisualProp then
  begin
    Options := TNonVisualProp(Source).Options;
    MinZoom := TNonVisualProp(Source).MinZoom;
    MaxZoom := TNonVisualProp(Source).MaxZoom;
  end
  else
    inherited Assign(Source);
end;

constructor TNonVisualProp.Create;
begin
  FMaxZoom := 0;
  FMinZoom := 0;
  FOptions := [Draggable, KeyboardShortcuts, ScrollWheel];
end;

procedure TNonVisualProp.SetMaxZoom(const Value: Integer);
begin
  if FMaxZoom = Value then Exit;

  FMaxZoom := Value;

  if FMaxZoom > 15 then FMaxZoom := 15;
  if FMaxZoom < 0 then FMaxZoom := 0;
end;

procedure TNonVisualProp.SetMinZoom(const Value: Integer);
begin
  if FMinZoom = Value then Exit;

  FMinZoom := Value;

  if FMinZoom > 15 then FMinZoom := 15;
  if FMinZoom < 0 then FMinZoom := 0;
end;

{ TGMLinkedComponent }

function TGMLinkedComponent.Add: TLinkedComponent;
begin
  Result := FVisualObjects.Add;
end;

procedure TGMLinkedComponent.Assign(Source: TPersistent);
begin
  if Source is TGMLinkedComponent then
  begin
    IdxList := TGMLinkedComponent(Source).IdxList;
    VisualObjects.Assign(TGMLinkedComponent(Source).VisualObjects);
    Map := TGMLinkedComponent(Source).Map;
    AutoUpdate := TGMLinkedComponent(Source).AutoUpdate;
  end
  else
    inherited Assign(Source);
end;

procedure TGMLinkedComponent.Clear;
begin
  FVisualObjects.Clear;
end;

function TGMLinkedComponent.GetCount: Integer;
begin
  Result := FVisualObjects.Count;
end;

constructor TGMLinkedComponent.Create(AOwner: TComponent);
begin
  inherited;

  FIdxList := 0;
  FVisualObjects := GetCollectionClass.Create(Self, GetCollectionItemClass);
  FAutoUpdate := True;
end;

procedure TGMLinkedComponent.Delete(Index: Integer);
begin
  FVisualObjects.Delete(Index);
end;

procedure TGMLinkedComponent.DeleteMapObjects;
begin
  ExecuteScript('DeleteObjects', IntToStr(IdxList));
end;

destructor TGMLinkedComponent.Destroy;
begin
  if Assigned(FVisualObjects) then FreeAndNil(FVisualObjects);

  inherited;
end;

procedure TGMLinkedComponent.ErrorControl;
var
  WC: TWebControl;
  ErrCode: Integer;
begin
  if not Assigned(Map) or not Map.Active then Exit;

  WC := TWebControl.Create(Map.WebBrowser);
  try
    ErrCode := WC.GetIntegerField(ErrorForm, ErrorFormErrorCode);
  finally
    if Assigned(WC) then FreeAndNil(WC);
  end;

  case ErrCode of
    1: // objeto no encontrado en JavaScript // Object not find in JavaScript
      raise Exception.Create(GetTranslateText('Este objeto no tiene relacin en JavaScript', Map.Language));
  end;
end;

procedure TGMLinkedComponent.EventFired(EventType: TEventType;
  Params: array of const);
begin
  inherited;

  if EventType = etInfoWinCloseClick then
    if Assigned(OnCloseClick) then OnCloseClick(Self, Params[0].VInteger, Items[Params[0].VInteger]);
end;

function TGMLinkedComponent.GetCollectionClass: TLinkedComponentsClass;
begin
  Result := TLinkedComponents;
end;

function TGMLinkedComponent.GetCollectionItemClass: TLinkedComponentClass;
begin
  Result := TLinkedComponent;
end;

function TGMLinkedComponent.GetItems(I: Integer): TLinkedComponent;
begin
  Result := TLinkedComponent(FVisualObjects[i]);
end;

procedure TGMLinkedComponent.Move(CurIndex, NewIndex: Integer);
begin
  FVisualObjects.Move(CurIndex, NewIndex);
end;

procedure TGMLinkedComponent.SetIdxList(const Value: Cardinal);
var
  i: Integer;
begin
  if FIdxList = Value then Exit;

  FIdxList := Value;
  if Assigned(FVisualObjects) then
    for i := 0 to FVisualObjects.Count - 1 do
      Items[i].IdxList := FIdxList;
end;

{ TLinkedComponents }

function TLinkedComponents.Add: TLinkedComponent;
begin
  Result := TLinkedComponent(inherited Add);

  if Assigned(FGMLinkedComponent) and FGMLinkedComponent.AutoUpdate then
    FGMLinkedComponent.ShowElements;
end;

procedure TLinkedComponents.Assign(Source: TPersistent);
begin
  inherited;

  if Source is TLinkedComponents then
    FGMLinkedComponent := TLinkedComponents(Source).FGMLinkedComponent;
end;

procedure TLinkedComponents.Clear;
begin
  inherited Clear;

  if Assigned(FGMLinkedComponent) and FGMLinkedComponent.AutoUpdate then
    FGMLinkedComponent.ShowElements;
end;

constructor TLinkedComponents.Create(GMLinkedComponent: TGMLinkedComponent;
  ItemClass: TCollectionItemClass);
begin
  inherited Create(ItemClass);

  FGMLinkedComponent := GMLinkedComponent;
end;

procedure TLinkedComponents.Delete(Index: Integer);
begin
  inherited Delete(Index);

  if Assigned(FGMLinkedComponent) and FGMLinkedComponent.AutoUpdate then
    FGMLinkedComponent.ShowElements;
end;

function TLinkedComponents.GetItems(I: Integer): TLinkedComponent;
begin
  Result := TLinkedComponent(inherited Items[I]);
end;

function TLinkedComponents.GetOwner: TPersistent;
begin
  Result := FGMLinkedComponent;
end;

function TLinkedComponents.Insert(Index: Integer): TLinkedComponent;
begin
  Result := TLinkedComponent(inherited Insert(Index));

  if Assigned(FGMLinkedComponent) and FGMLinkedComponent.AutoUpdate then
    FGMLinkedComponent.ShowElements;
end;

procedure TLinkedComponents.Move(CurIndex, NewIndex: Integer);
begin
  Items[CurIndex].Index := NewIndex;

  if Assigned(FGMLinkedComponent) and FGMLinkedComponent.AutoUpdate then
    FGMLinkedComponent.ShowElements;
end;

procedure TLinkedComponents.SetItems(I: Integer; const Value: TLinkedComponent);
begin
  inherited SetItem(I, Value);
end;

{ TLinkedComponent }

procedure TLinkedComponent.Assign(Source: TPersistent);
begin
  if Source is TLinkedComponent then
  begin
    IdxList := TLinkedComponent(Source).IdxList;
    InfoWindow.Assign(TLinkedComponent(Source).InfoWindow);
  end
  else
    inherited Assign(Source);
end;

constructor TLinkedComponent.Create(Collection: TCollection);
begin
  inherited;

  FText := Self.ClassName;
  FInfoWindow := TBaseInfoWindow.Create(Self);
  FInfoWindow.OnCloseOtherBeforeOpenChange := OnCloseOtherBeforeOpenChange;
  FInfoWindow.OnHTMLContentChange := OnHTMLContentChange;
  FInfoWindow.OnDisableAutoPanChange := OnDisableAutoPanChange;
  FInfoWindow.OnMaxWidthChange := OnMaxWidthChange;
  FInfoWindow.OnPixelOffsetChange := OnPixelOffsetChange;
  FShowInfoWinMouseOver := False;

  FIdxList := 0;
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) then
    FIdxList := TLinkedComponents(Collection).FGMLinkedComponent.IdxList;
end;

destructor TLinkedComponent.Destroy;
begin
  if Assigned(FInfoWindow) then FreeAndNil(FInfoWindow);

  inherited;
end;

function TLinkedComponent.GetDisplayName: string;
begin
  if Length(FText) > 0 then
  begin
    if Length(FText) > 15 then
      Result := Copy(FText, 0, 15) + '...'
    else
      Result := FText;
  end
  else
  begin
    Result := inherited GetDisplayName;
    FText := Result;
  end;
end;

procedure TLinkedComponent.OnCloseOtherBeforeOpenChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      LowerCase(BoolToStr(FInfoWindow.CloseOtherBeforeOpen, True)),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetCloseOtherBeforeOpen', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnCloseOtherBeforeOpenChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnCloseOtherBeforeOpenChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnDisableAutoPanChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      LowerCase(BoolToStr(FInfoWindow.DisableAutoPan, True)),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetDisableAutoPan', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnDisableAutoPanChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnDisableAutoPanChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnHTMLContentChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      QuotedStr(FInfoWindow.GetConvertedString),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetHTMLContent', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnHTMLContentChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnHTMLContentChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnMaxWidthChange(Sender: TObject);
const
  StrParams = '%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      IntToStr(FInfoWindow.MaxWidth),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetMaxWidth', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnMaxWidthChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnMaxWidthChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.OnPixelOffsetChange(Sender: TObject);
const
  StrParams = '%s,%s,%s,%s';
var
  Params: string;
begin
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    Params := Format(StrParams, [
                      IntToStr(FIdxList),
                      IntToStr(FInfoWindow.PixelOffset.Height),
                      IntToStr(FInfoWindow.PixelOffset.Width),
                      IntToStr(Index)]);
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript('InfoWindowSetPixelOffset', Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    if Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnPixelOffsetChange) then
      TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).OnPixelOffsetChange(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

procedure TLinkedComponent.SetIdxList(const Value: Cardinal);
begin
  if FIdxList = Value then Exit;

  FIdxList := Value;
end;

function TLinkedComponent.SetProperty(FunctionName, EventName, Value: string;
  Quoted: Boolean): Boolean;
const
  StrParams = '%s,%s,%s';
var
  Params: string;
  Event: TMethod;
  Tmp: string;
begin
  Result := False;
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
  begin
    if csDesigning in TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ComponentState then Exit;

    Tmp := TLinkedComponents(Collection).FGMLinkedComponent.GetConvertedString(Value);
    if Quoted then Tmp := QuotedStr(Tmp);

    Params := Format(StrParams, [
                      IntToStr(IdxList),
                      Tmp,
                      IntToStr(Index)]);
    Result := TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript(FunctionName, Params);

    // ES: control de errores // EN: error control
    TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

    // ES/EN: evento/event
    Event := GetMethodProp(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), EventName);

    if Assigned(Event.Code) and Result then
      TLinkedComponentChange(Event)(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
  end;
end;

function TLinkedComponent.SetProperty(FunctionName, EventName: string;
  Value: Boolean): Boolean;
begin
  Result := SetProperty(FunctionName, EventName, LowerCase(BoolToStr(Value, True)), False);
end;

function TLinkedComponent.SetProperty(FunctionName, EventName: string;
  Value: Integer): Boolean;
begin
  Result := SetProperty(FunctionName, EventName, IntToStr(Value), False);
end;

function TLinkedComponent.SetProperty(FunctionName, EventName: string;
  Value: Real): Boolean;
begin
  Result := SetProperty(FunctionName, EventName, StringReplace(FloatToStr(Value), ',', '.', [rfReplaceAll]), False);
end;

{
  ES: devido a un bug que hay en versiones anteriores a D2009 con la sobrecarga de
      mtodos, tengo que declarar ste con un nombre especfico para l
  EN: for a bug in previous versions to D2009 with overloaded methods, I need to
      declare this method with a specific name
}
{$IF CompilerVersion < 20}  // ES: si la versin es inferior a D2009 - EEN: if lower than D2009 version
function TLinkedComponent.SetColorProperty(FunctionName, EventName: string;
  Value: TColor): Boolean;
{$ELSE}
{function TLinkedComponent.SetProperties(FunctionName, EventName,
  Params: string): Boolean;
var
  Event: TMethod;
begin
  Result := False;
  if not Assigned(Collection) or not (Collection is TLinkedComponents) or
     not Assigned(TLinkedComponents(Collection).FGMLinkedComponent) or
     not TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate or
     not Assigned(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).Map) or
     (csDesigning in TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ComponentState) then
    Exit;

  Result := TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ExecuteScript(FunctionName, Params);

  // ES: control de errores // EN: error control
  TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).ErrorControl;

  // ES/EN: evento/event
  Event := GetMethodProp(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), EventName);

  if Assigned(Event.Code) and Result then
    TLinkedComponentChange(Event)(TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent), Index, Self);
end;}

function TLinkedComponent.SetProperty(FunctionName, EventName: string;
  Value: TColor): Boolean;
{$IFEND}
begin
  Result := False;
  if Assigned(Collection) and (Collection is TLinkedComponents) and
     Assigned(TLinkedComponents(Collection).FGMLinkedComponent) and
     TGMLinkedComponent(TLinkedComponents(Collection).FGMLinkedComponent).AutoUpdate then
    Result := SetProperty(FunctionName, EventName, TGMLinkedComponent(TLinkedComponents(Collection)).Map.TColorToStr(Value));
end;

procedure TLinkedComponent.SetShowInfoWinMouseOver(const Value: Boolean);
begin
  if FShowInfoWinMouseOver = Value then Exit;

  FShowInfoWinMouseOver := Value;
  ChangeProperties;
end;

{ TGMObjects }

destructor TGMObjects.Destroy;
begin
  if Assigned(FMap) then FMap.RemoveLinkedComponent(Self);

  inherited;
end;

function TGMObjects.ExecuteScript(NameFunct, Params: string): Boolean;
begin
  Result := False;
  if (csDesigning in ComponentState) or not Assigned(FMap) or
     not Map.Active or not Map.FDocLoaded then Exit;

  Result := FMap.ExecuteScript(NameFunct, Params);
end;

procedure TGMObjects.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;

  if (Operation = opRemove) and (AComponent <> nil) and (AComponent = FMap) then
    FMap := nil;
end;

procedure TGMObjects.SetIdxList(const Value: Cardinal);
begin
  if FIdxList = Value then Exit;

  FIdxList := Value;
end;

procedure TGMObjects.SetMap(const Value: TGMMap);
begin
  if FMap = Value then Exit;

  if Assigned(FMap) then
  begin
    if not (csDesigning in ComponentState) and (FIdxList <> 0) and
      Map.Active and Map.FDocLoaded then
    begin
      DeleteMapObjects;
      IdxList := 0;
    end;
    FMap.RemoveLinkedComponent(Self);
  end;
  FMap := Value;
  if Assigned(FMap) then
  begin
    {IdxList := }FMap.AddLinkedComponent(Self);
    if not (csDesigning in ComponentState) and (FIdxList <> 0) and
       Map.Active and Map.FDocLoaded then ShowElements;
  end;
end;

{ TPanoramio }

procedure TPanoramio.Assign(Source: TPersistent);
begin
  if Source is TPanoramio then
  begin
    FGMMap := TPanoramio(Source).FGMMap;
    Show := TPanoramio(Source).Show;
    Filtered := TPanoramio(Source).Filtered;
    FilterTag := TPanoramio(Source).FilterTag;
    FilterUserId := TPanoramio(Source).FilterUserId;
    Clickable := TPanoramio(Source).Clickable;
  end
  else inherited;
end;

constructor TPanoramio.Create(GMMap: TGMMap);
begin
  FGMMap := GMMap;
  FShow := False;
  FFiltered := False;
  FFilterTag := '';
  FFilterUserId := '';
  FClickable := True;
end;

procedure TPanoramio.SetClickable(const Value: Boolean);
begin
  if FClickable = Value then Exit;

  FClickable := Value;
  SetOptions;
end;

procedure TPanoramio.SetFilterTag(const Value: string);
begin
  if FFilterTag = Value then Exit;

  FFilterTag := Value;
  if FFiltered then SetOptions;
end;

procedure TPanoramio.SetFilterUserId(const Value: string);
begin
  if FFilterUserId = Value then Exit;

  FFilterUserId := Value;
  if FFiltered then SetOptions;
end;

procedure TPanoramio.SetOptions;
const
  StrParams = '%s,%s,%s,%s';
var
  Params: String;
begin
  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
  begin
    Params := Format(StrParams, [
               LowerCase(BoolToStr(FClickable, True)),
               LowerCase(BoolToStr(FFiltered, True)),
               QuotedStr(FGMMap.GetConvertedString(FFilterTag)),
               QuotedStr(FGMMap.GetConvertedString(FFilterUserId))
               ]);
    FGMMap.ExecuteScript('MapsPanoramioOptions', Params);
  end;
end;

procedure TPanoramio.SetFiltered(const Value: Boolean);
begin
  if FFiltered = Value then Exit;

  FFiltered := Value;
  SetOptions;
end;

procedure TPanoramio.SetShow(const Value: Boolean);
begin
  if FShow = Value then Exit;

  FShow := Value;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
    FGMMap.ExecuteScript('MapsControlPanoramio', LowerCase(BoolToStr(FShow, True)));
end;

{ TLayers }

procedure TLayers.Assign(Source: TPersistent);
begin
  if Source is TLayers then
  begin
    Panoramio.Assign(TLayers(Source).Panoramio);
    Traffic.Assign(TLayers(Source).Traffic);
    Transit.Assign(TLayers(Source).Transit);
    Bicycling.Assign(TLayers(Source).Bicycling);
    Weather.Assign(TLayers(Source).Weather);
  end
  else inherited;
end;

constructor TLayers.Create(GMMap: TGMMap);
begin
  FGMMap := GMMap;
  FPanoramio := TPanoramio.Create(FGMMap);
  FTraffic := TTraffic.Create(FGMMap);
  FTransit := TTransit.Create(FGMMap);
  FBicycling := TBicycling.Create(FGMMap);
  FWeather := TWeather.Create(FGMMap);
end;

destructor TLayers.Destroy;
begin
  if Assigned(FPanoramio) then FreeAndNil(FPanoramio);
  if Assigned(FTraffic) then FreeAndNil(FTraffic);
  if Assigned(FTransit) then FreeAndNil(FTransit);
  if Assigned(FBicycling) then FreeAndNil(FBicycling);
  if Assigned(FWeather) then FreeAndNil(FWeather);

  inherited;
end;

{ TTraffic }

procedure TTraffic.Assign(Source: TPersistent);
begin
  if Source is TPanoramio then
  begin
    FGMMap := TPanoramio(Source).FGMMap;
    FShow := TPanoramio(Source).FShow;
  end
  else inherited;
end;

constructor TTraffic.Create(GMMap: TGMMap);
begin
  FGMMap := GMMap;
  FShow := False;
end;

procedure TTraffic.SetShow(const Value: Boolean);
begin
  if FShow = Value then Exit;

  FShow := Value;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
    FGMMap.ExecuteScript('MapsControlTraffic', LowerCase(BoolToStr(FShow, True)));
end;

{ TTransit }

procedure TTransit.Assign(Source: TPersistent);
begin
  if Source is TPanoramio then
  begin
    FGMMap := TPanoramio(Source).FGMMap;
    FShow := TPanoramio(Source).FShow;
  end
  else inherited;
end;

constructor TTransit.Create(GMMap: TGMMap);
begin
  FGMMap := GMMap;
  FShow := False;
end;

procedure TTransit.SetShow(const Value: Boolean);
begin
  if FShow = Value then Exit;

  FShow := Value;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
    FGMMap.ExecuteScript('MapsControlTransit', LowerCase(BoolToStr(FShow, True)));
end;

{ TBicycling }

procedure TBicycling.Assign(Source: TPersistent);
begin
  if Source is TPanoramio then
  begin
    FGMMap := TPanoramio(Source).FGMMap;
    FShow := TPanoramio(Source).FShow;
  end
  else inherited;
end;

constructor TBicycling.Create(GMMap: TGMMap);
begin
  FGMMap := GMMap;
  FShow := False;
end;

procedure TBicycling.SetShow(const Value: Boolean);
begin
  if FShow = Value then Exit;

  FShow := Value;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
    FGMMap.ExecuteScript('MapsControlBicycling', LowerCase(BoolToStr(FShow, True)));
end;

{ TWeather }

procedure TWeather.Assign(Source: TPersistent);
begin
  if Source is TWeather then
  begin
    FGMMap := TWeather(Source).FGMMap;
    Show := TWeather(Source).Show;
    Clickable := TWeather(Source).Clickable;
    LabelColor := TWeather(Source).LabelColor;
    SuppressInfoWindows := TWeather(Source).SuppressInfoWindows;
    TemperatureUnit := TWeather(Source).TemperatureUnit;
    WindSpeedUnit := TWeather(Source).WindSpeedUnit;
  end
  else inherited;
end;

constructor TWeather.Create(GMMap: TGMMap);
begin
  FGMMap := GMMap;
  FShow := False;
  FClickable := True;
  FLabelColor := lcBLACK;
  FSuppressInfoWindows := False;
  FTemperatureUnit := tuCELSIUS;
  FWindSpeedUnit := wsKILOMETERS_PER_HOUR;
end;

procedure TWeather.SetClickable(const Value: Boolean);
begin
  if FClickable = Value then Exit;

  FClickable := Value;
  SetOptions;
end;

procedure TWeather.SetLabelColor(const Value: TLabelColor);
begin
  if FLabelColor = Value then Exit;

  FLabelColor := Value;
  SetOptions;
end;

procedure TWeather.SetOptions;
const
  StrParams = '%s,%s,%s,%s,%s';
var
  Params: string;
begin
  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
  begin
    Params := Format(StrParams, [
               LowerCase(BoolToStr(FClickable, True)),
               LowerCase(BoolToStr(FSuppressInfoWindows, True)),
               QuotedStr(TTransform.LabelColorToStr(FLabelColor)),
               QuotedStr(TTransform.TemperatureUnitToStr(FTemperatureUnit)),
               QuotedStr(TTransform.WindSpeedUnitToStr(FWindSpeedUnit))
               ]);
    FGMMap.ExecuteScript('MapsWeatherOptions', Params);
  end;
end;

procedure TWeather.SetShow(const Value: Boolean);
begin
  if FShow = Value then Exit;

  FShow := Value;

  if Assigned(FGMMap.FWebBrowser) and FGMMap.FActive and FGMMap.FDocLoaded and
     FGMMap.FIsDoMap then
    FGMMap.ExecuteScript('MapsControlWeather', LowerCase(BoolToStr(FShow, True)));
end;

procedure TWeather.SetSuppressInfoWindows(const Value: Boolean);
begin
  if FSuppressInfoWindows = Value then Exit;

  FSuppressInfoWindows := Value;
  SetOptions;
end;

procedure TWeather.SetTemperatureUnit(const Value: TTemperatureUnit);
begin
  if FTemperatureUnit = Value then Exit;

  FTemperatureUnit := Value;
  SetOptions;
end;

procedure TWeather.SetWindSpeedUnit(const Value: TWindSpeedUnit);
begin
  if FWindSpeedUnit = Value then Exit;

  FWindSpeedUnit := Value;
  SetOptions;
end;

{ TWeatherFeature }

constructor TWeatherFeature.Create;
begin
  FForecast := TObjectList.Create;
  FCurrent := TWeatherConditions.Create;
end;

destructor TWeatherFeature.Destroy;
begin
  if Assigned(FForecast) then FreeAndNil(FForecast);
  if Assigned(FCurrent) then FreeAndNil(FCurrent);

  inherited;
end;

function TWeatherFeature.GetCount: Integer;
begin
  Result := FForecast.Count;
end;

function TWeatherFeature.GetForecast(Index: Integer): TWeatherForecast;
begin
  Result := nil;
  if Assigned(FForecast[Index]) then
    Result := TWeatherForecast(FForecast[Index]);
end;

procedure TWeatherFeature.ProcessXMLData(Data: string);
var
  XML: IXMLDocument;

  procedure ParseNodes(Node: IXMLNode);
  var
    Tmp: IXMLNode;
    Forecast: TWeatherForecast;
  begin
    // ES: nos posicionamos en "WeatherFeature" // EN: go to "WeatherFeature" tag
    while Assigned(Node) and (Node.NodeName <> LBL_WEATHERFEATURE) do
      Node := Node.NextSibling;

    if not Assigned(Node) or (Node.ChildNodes.Count = 0) then Exit;
    Node := Node.ChildNodes.First;

    while Assigned(Node) do
    begin
      // ES: etiqueta "location" (slo una)   // EN: "location" tag (only one)
      if Node.NodeName = LBL_W_LOCATION then FLocation := Node.NodeValue;

      // ES: etiqueta "temperatureUnit" (slo una)   // EN: "temperatureUnit" tag (only one)
      if Node.NodeName = LBL_W_TEMPERATUREUNIT then
        FTemperatureUnit := TTransform.StrToTemperatureUnit(Node.NodeValue);

      // ES: etiqueta "windSpeedUnit" (slo una)   // EN: "windSpeedUnit" tag (only one)
      if Node.NodeName = LBL_W_WINDSPEEDUNIT then
        FWindSpeedUnit := TTransform.StrToWindSpeedUnit(Node.NodeValue);

      // ES: etiqueta "current" (slo una)   // EN: "current" tag (only one)
      if (Node.NodeName = LBL_W_CURRENT) and (Node.ChildNodes.Count > 0) then
      begin
        Tmp := Node.ChildNodes.First;
        while Assigned(Tmp) do
        begin
          if Tmp.NodeName = LBL_W_DAY then FCurrent.FDay := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_DESCRIPTION then FCurrent.FDescription := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_HIGH then FCurrent.FHigh := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_HUMIDITY then FCurrent.FHumidity := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_LOW then FCurrent.FLow := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_SHORTDAY then FCurrent.FShortDay := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_TEMPERATURE then FCurrent.FTemperature := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_WINDDIRECTION then FCurrent.FWindDirection := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_WINDSPEED then FCurrent.FWindSpeed := Tmp.NodeValue;

          Tmp := Tmp.NextSibling;
        end;
      end;

      // ES: etiqueta "forecast" (normalmente 4)   // EN: "forecast" tag (normally 4)
      if (Node.NodeName = LBL_W_FORECAST) and (Node.ChildNodes.Count > 0) then
      begin
        Forecast := TWeatherForecast.Create;
        Tmp := Node.ChildNodes.First;
        while Assigned(Tmp) do
        begin
          if Tmp.NodeName = LBL_W_DAY then Forecast.FDay := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_DESCRIPTION then Forecast.FDescription := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_HIGH then Forecast.FHigh := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_LOW then Forecast.FLow := Tmp.NodeValue;
          if Tmp.NodeName = LBL_W_SHORTDAY then Forecast.FShortDay := Tmp.NodeValue;

          Tmp := Tmp.NextSibling;
        end;
        FForecast.Add(Forecast);
      end;

      Node := Node.NextSibling;
    end;
  end;
begin
  FForecast.Clear;

  XML := TXMLDocument.Create(nil);
  try
    XML.LoadFromXML(Data);
    XML.Active := True;
    ParseNodes(XML.ChildNodes.First);
  finally
    XML := nil;
  end;
end;

end.
